package cn.ezhizao.project.business.BizInspectionStandards.domain;

import cn.ezhizao.framework.aspectj.lang.annotation.Excel;
import cn.ezhizao.framework.web.domain.BaseEntity;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableName;
import lombok.Data;
import io.swagger.annotations.ApiModelProperty;


/**
 * 检查标准对象 biz_inspection_standards
 *
 * @author ezhizao
 * @date 2024-08-09
 */
@Data
@TableName(value = "biz_inspection_standards")
public class BizInspectionStandards extends BaseEntity
{
    private static final long serialVersionUID = 1L;

    /** 租户id，厂别或类型1:Ⅰ类2：Ⅱ类 */
    @ApiModelProperty(value = "${comment}")
    private Long tenantId;

    /** 检查仪器 */
    @Excel(name = "检查仪器")
    @ApiModelProperty(value = "检查仪器")
    private String instrument;

    /** 产品版本 */
    @Excel(name = "产品版本")
    @ApiModelProperty(value = "产品版本")
    private String productVersion;

    /** 工序编码 */
    @Excel(name = "工序编码")
    @ApiModelProperty(value = "工序编码")
    private String processCode;

    /** 检查标准 */
    @Excel(name = "检查标准")
    @ApiModelProperty(value = "检查标准")
    private String standard;

    /** 产品id */
    @ApiModelProperty(value = "检查标准")
    private Long productId;

    /** 工序id */
    @ApiModelProperty(value = "检查标准")
    private Long processId;

    private Long inspecionStandardsId;
    @TableField(exist = false)
    private String inspectionCode;

}
