package cn.ezhizao.project.business.app.service.impl;

import java.util.List;
import javax.annotation.Resource;

import cn.ezhizao.project.business.app.domain.BizApp;
import cn.ezhizao.project.business.app.mapper.BizAppMapper;
import cn.ezhizao.project.business.app.service.IBizAppService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.stereotype.Service;

/**
 * app管理Service业务层处理
 *
 * @author ezhizao
 * @date 2024-01-24
 */
@Service
public class BizAppServiceImpl  extends ServiceImpl<BizAppMapper, BizApp> implements IBizAppService
{
    @Resource
    private BizAppMapper bizAppMapper;

    /**
     * 查询app管理列表
     *
     * @param bizApp app管理
     * @return app管理
     */
    @Override
    public List<BizApp> getList(BizApp bizApp)
    {
        return bizAppMapper.getList(bizApp);
    }

    /**
     * 物理删除
     * @param bizApp
     * @return 删除结果
     */
    @Override
    public int physicalDelete(BizApp bizApp){ return bizAppMapper.physicalDelete(bizApp); };

}
