package cn.ezhizao.project.business.equipment.domain;

import cn.ezhizao.framework.aspectj.lang.annotation.Excel;
import cn.ezhizao.framework.web.domain.BaseEntity;
import com.baomidou.mybatisplus.annotation.TableName;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;


/**
 * 设备档案对象 biz_equipment
 *
 * @author ezhizao
 * @date 2023-11-14
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName(value = "biz_equipment")
public class BizEquipment extends BaseEntity {
    private static final long serialVersionUID = 1L;

    /**
     * 设备档案id（直属类别id）
     */
    @ApiModelProperty(value = "设备档案id（直属类别id）")
    private Long equipmentCategoryId;

    /**
     * 设备档案名称
     */
    @Excel(name = "设备名称")
    @ApiModelProperty(value = "设备名称")
    private String equipmentName;

    /**
     * 规格型号
     */
    @Excel(name = "规格型号")
    @ApiModelProperty(value = "规格型号")
    private String standard;

    /**
     * 设备数量
     */
    @Excel(name = "设备数量")
    @ApiModelProperty(value = "设备数量")
    private Integer equipmentNumber;

    /**
     * 设备备注
     */
    @Excel(name = "设备备注")
    @ApiModelProperty(value = "设备备注")
    private String remark;

    /**
     * 排序
     */
    @Excel(name = "排序")
    @ApiModelProperty(value = "排序")
    private Integer sort;

}
