package cn.ezhizao.project.business.equipment.domain;

import cn.ezhizao.framework.aspectj.lang.annotation.Excel;
import cn.ezhizao.framework.web.domain.BaseEntity;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableName;
import lombok.Data;
import io.swagger.annotations.ApiModelProperty;


/**
 * 员工绑定设备对象 biz_user_equipment
 *
 * @author ezhizao
 * @date 2023-12-08
 */
@Data
@TableName(value = "biz_user_equipment")
public class BizUserEquipment extends BaseEntity
{
    private static final long serialVersionUID = 1L;

    /** 用户id */
    @ApiModelProperty(value = "${comment}")
    private Long userId;

    /** 员工姓名 */
    @Excel(name = "员工姓名")
    @ApiModelProperty(value = "员工姓名")
    private String nickName;

    /** 设备id */
    @ApiModelProperty(value = "员工姓名")
    private Long equipmentDetailId;

    /** 设备编码 */
    @Excel(name = "设备编码")
    @ApiModelProperty(value = "设备编码")
    private String equipmentDetailCode;

    /** 设备部门id */
    @ApiModelProperty(value = "设备编码")
    private Long deptId;


    private Long tenantId;

    @TableField(exist = false)
    private Long processId;
    private Long groupId;

}
