package cn.ezhizao.project.business.equipment.mapper;

import java.util.List;

import cn.ezhizao.project.business.equipment.domain.BizUserEquipment;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;


/**
 * 员工绑定设备Mapper接口
 *
 * @author ezhizao
 * @date 2023-12-08
 */
public interface BizUserEquipmentMapper extends BaseMapper<BizUserEquipment>
{
    /**
     * 查询员工绑定设备列表
     *
     * @param bizUserEquipment 员工绑定设备
     * @return 员工绑定设备集合
     */
    public List<BizUserEquipment> getList(BizUserEquipment bizUserEquipment);

    /**
     * 物理删除
     * @param bizUserEquipment
     * @return 删除结果
    */
    public int physicalDelete(BizUserEquipment bizUserEquipment);

    /**
     * 保存人员绑定设备信息
     * @param bizUserEquipment
     * @return
     */
    int saveUserEquipment(BizUserEquipment bizUserEquipment);
}
