package cn.ezhizao.project.business.equipment.service.impl;

import java.util.List;
import javax.annotation.Resource;

import cn.ezhizao.project.business.equipment.domain.BizEquipmentDetail;
import cn.ezhizao.project.business.equipment.service.IBizEquipmentDetailService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.stereotype.Service;
import cn.ezhizao.project.business.equipment.mapper.BizEquipmentDetailMapper;

/**
 * 设备档案Service业务层处理
 *
 * @author ezhizao
 * @date 2023-11-14
 */
@Service
public class BizEquipmentDetailServiceImpl  extends ServiceImpl<BizEquipmentDetailMapper, BizEquipmentDetail> implements IBizEquipmentDetailService
{
    @Resource
    private BizEquipmentDetailMapper bizEquipmentDetailMapper;

    /**
     * 查询设备档案列表
     *
     * @param bizEquipmentDetail 设备档案
     * @return 设备档案
     */
    @Override
    public List<BizEquipmentDetail> getList(BizEquipmentDetail bizEquipmentDetail)
    {
        return bizEquipmentDetailMapper.getList(bizEquipmentDetail);
    }

    @Override
    public Long getUsageDeptIdByEquipmentDetailsId(Long equipmentDetailsId) {
        return bizEquipmentDetailMapper.getUsageDeptIdByEquipmentDetailsId(equipmentDetailsId);
    }

    /**
     * 物理删除
     * @param bizEquipmentDetail
     * @return 删除结果
     */
    @Override
    public int physicalDelete(BizEquipmentDetail bizEquipmentDetail){ return bizEquipmentDetailMapper.physicalDelete(bizEquipmentDetail); };

}
