package cn.ezhizao.project.business.innerTurnover.service.impl;

import java.util.List;
import javax.annotation.Resource;

import cn.ezhizao.project.business.innerTurnover.domain.BizInnerTurnover;
import cn.ezhizao.project.business.innerTurnover.mapper.BizInnerTurnoverMapper;
import cn.ezhizao.project.business.innerTurnover.service.IBizInnerTurnoverService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.stereotype.Service;


/**
 * 工段内部人周转表Service业务层处理
 *
 * @author ezhizao
 * @date 2024-07-08
 */
@Service
public class BizInnerTurnoverServiceImpl  extends ServiceImpl<BizInnerTurnoverMapper, BizInnerTurnover> implements IBizInnerTurnoverService
{
    @Resource
    private BizInnerTurnoverMapper bizInnerTurnoverMapper;

    /**
     * 查询工段内部人周转表列表
     *
     * @param bizInnerTurnover 工段内部人周转表
     * @return 工段内部人周转表
     */
    @Override
    public List<BizInnerTurnover> getList(BizInnerTurnover bizInnerTurnover)
    {
        return bizInnerTurnoverMapper.getList(bizInnerTurnover);
    }

    /**
     * 物理删除
     * @param bizInnerTurnover
     * @return 删除结果
     */
    @Override
    public int physicalDelete(BizInnerTurnover bizInnerTurnover){ return bizInnerTurnoverMapper.physicalDelete(bizInnerTurnover); };

}
