package cn.ezhizao.project.business.inspection.service.impl;

import java.util.List;
import javax.annotation.Resource;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.stereotype.Service;
import cn.ezhizao.project.business.inspection.mapper.BizProcessInspectionPictureMapper;
import cn.ezhizao.project.business.inspection.domain.BizProcessInspectionPicture;
import cn.ezhizao.project.business.inspection.service.IBizProcessInspectionPictureService;

/**
 * 电子图纸Service业务层处理
 *
 * @author ezhizao
 * @date 2024-09-26
 */
@Service
public class BizProcessInspectionPictureServiceImpl  extends ServiceImpl<BizProcessInspectionPictureMapper, BizProcessInspectionPicture> implements IBizProcessInspectionPictureService
{
    @Resource
    private BizProcessInspectionPictureMapper bizProcessInspectionPictureMapper;

    /**
     * 查询电子图纸列表
     *
     * @param bizProcessInspectionPicture 电子图纸
     * @return 电子图纸
     */
    @Override
    public List<BizProcessInspectionPicture> getList(BizProcessInspectionPicture bizProcessInspectionPicture)
    {
        return bizProcessInspectionPictureMapper.getList(bizProcessInspectionPicture);
    }

    /**
     * 物理删除
     * @param bizProcessInspectionPicture
     * @return 删除结果
     */
    @Override
    public int physicalDelete(BizProcessInspectionPicture bizProcessInspectionPicture){ return bizProcessInspectionPictureMapper.physicalDelete(bizProcessInspectionPicture); };

}
