package cn.ezhizao.project.business.notification.domain;

import cn.ezhizao.framework.aspectj.lang.annotation.Excel;
import cn.ezhizao.framework.web.domain.BaseEntity;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableName;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

/**
 * 发版通知公告对象 sys_notification
 *
 * @author ezhizao
 * @date 2025-01-08
 */
@Data
@TableName(value = "sys_notification")
public class SysNotification extends BaseEntity
{
    private static final long serialVersionUID = 1L;

    /** 公告标题 */
    @Excel(name = "公告标题")
    @ApiModelProperty(value = "公告标题")
    private String title;

    /** 公告类型（1公告 2发版） */
    @Excel(name = "公告类型", readConverterExp = "1=公告,2=发版")
    @ApiModelProperty(value = "公告类型")
    private Integer type;

    /** 公告内容 */
    @Excel(name = "公告内容")
    @ApiModelProperty(value = "公告内容")
    private String content;

    /** 更新中公告内容 */
    @Excel(name = "更新中公告内容")
    @ApiModelProperty(value = "更新中公告内容")
    private String updateContent;

    /** 公告状态（0 未开始 2 公告中 3更新中 4已完成） */
    @Excel(name = "公告状态", readConverterExp = "0=,未=开始,2=,公=告中,3=更新中,4=已完成")
    @ApiModelProperty(value = "公告状态")
    private Integer status;

    /** 更新者 */
    @ApiModelProperty(value = "公告状态")
    private String updateId;

    @TableField(exist = false)
    private Long tenantId;

}
