package cn.ezhizao.project.business.process.domain;

import cn.ezhizao.framework.aspectj.lang.annotation.Excel;
import cn.ezhizao.framework.web.domain.BaseEntity;
import cn.ezhizao.project.business.deptProcess.domain.BizDeptProcess;
import cn.ezhizao.project.business.product.domain.BizLotTechnologicalProcess;
import cn.ezhizao.project.business.product.domain.BizLotTechnologicalProcessDetail;
import cn.ezhizao.project.business.technologicalProcessDetail.domain.BizTechnologicalProcessDetail;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableName;

import lombok.Data;
import io.swagger.annotations.ApiModelProperty;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

import java.util.List;
import java.util.Objects;


/**
 * 标准工序对象 biz_process
 *
 * @author ezhizao
 * @date 2023-11-13
 */
@Data
@TableName(value = "biz_process")
public class BizProcess extends BaseEntity
{
    private static final long serialVersionUID = 1L;

    /** XX主序 XX次序 X分序 */
    @Excel(name = "XX主序 XX次序 X分序")
    @ApiModelProperty(value = "XX主序 XX次序 X分序")
    private String processCode;

    /** 工序简称 */
    @Excel(name = "工序简称")
    @ApiModelProperty(value = "工序简称")
    private String processAlias;

    /** NA正常,CL不用 */
    @Excel(name = "NA正常,CL不用")
    @ApiModelProperty(value = "NA正常,CL不用")
    private String status;

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        BizProcess that = (BizProcess) o;
        return Objects.equals(processCode, that.processCode) && Objects.equals(processAlias, that.processAlias) && Objects.equals(status, that.status) && Objects.equals(remark, that.remark);
    }

    @Override
    public int hashCode() {
        return Objects.hash(processCode, processAlias, status, remark);
    }

    @Excel(name = "备注")
    @ApiModelProperty(value = "备注")
    @TableField(exist = true)
    private String remark;

    @TableField(exist = false)
    private List<BizDeptProcess> deptProcess;

    @TableField(exist = false)
    private Long technologicalProcessDetailId;
    @TableField(exist = false)
    private String processStepNumber;
    private Long tenantId;

    public BizProcess() {}

    public BizProcess(BizLotTechnologicalProcessDetail p) {
        this.setId(p.getProcessId());
        this.setProcessCode(p.getProcessCode());
        this.setProcessAlias(p.getProcessAlias());
        this.setProcessStepNumber(p.getProcessStepNumber());
        this.setTechnologicalProcessDetailId(p.getId());
    }

    public BizProcess(BizTechnologicalProcessDetail p) {
        this.setId(p.getProcessId());
        this.setProcessCode(p.getProcessCode());
        this.setProcessAlias(p.getProcessAlias());
        this.setProcessStepNumber(p.getProcessStepNumber());
        this.setTechnologicalProcessDetailId(p.getId());
    }
}
