package cn.ezhizao.project.business.process.service;

import java.util.List;

import cn.ezhizao.project.business.process.domain.BizProcess;
import com.baomidou.mybatisplus.extension.service.IService;


/**
 * 标准工序Service接口
 *
 * @author ezhizao
 * @date 2023-11-13
 */
public interface IBizProcessService extends IService<BizProcess>
{
    /**
     * 查询标准工序列表
     *
     * @param bizProcess 标准工序
     * @return 标准工序集合
     */
    public List<BizProcess> getList(BizProcess bizProcess);

    /**
     * 物理删除
     * @param bizProcess
     * @return 删除结果
     */
    public int physicalDelete(BizProcess bizProcess);

    /**
     * 查询员工负责工序列表
     *
     *  标准工序
     * @return 标准工序集合
     */
    public List<BizProcess> getUserProcess(List<Long> ids);

}
