package cn.ezhizao.project.business.product.controller;

import cn.ezhizao.common.exception.ServiceException;
import cn.ezhizao.common.utils.SecurityUtils;
import cn.ezhizao.common.utils.StringUtils;
import cn.ezhizao.common.utils.poi.ExcelUtil;
import cn.ezhizao.framework.aspectj.lang.annotation.Log;
import cn.ezhizao.framework.aspectj.lang.enums.BusinessType;
import cn.ezhizao.framework.web.controller.BaseController;
import cn.ezhizao.framework.web.domain.AjaxResult;
import cn.ezhizao.framework.web.page.TableDataInfo;
import cn.ezhizao.project.business.deptProcess.domain.BizDeptProcess;
import cn.ezhizao.project.business.deptProcess.service.IBizDeptProcessService;
import cn.ezhizao.project.business.outsource.domain.BizOutsourcedOrderDetailProcess;
import cn.ezhizao.project.business.outsource.service.IBizOutsourcedOrderDetailProcessService;
import cn.ezhizao.project.business.process.domain.BizProcess;
import cn.ezhizao.project.business.process.service.IBizProcessService;
import cn.ezhizao.project.business.product.domain.*;
import cn.ezhizao.project.business.product.service.*;
import cn.ezhizao.project.business.resourceGroup.domain.BizProductionResourceGroup;
import cn.ezhizao.project.business.resourceGroup.domain.BizProductionResourceGroupDetail;
import cn.ezhizao.project.business.resourceGroup.domain.BizProductionResourceGroupSubPlan;
import cn.ezhizao.project.business.resourceGroup.service.IBizProductionResourceGroupDetailService;
import cn.ezhizao.project.business.resourceGroup.service.IBizProductionResourceGroupService;
import cn.ezhizao.project.business.resourceGroup.service.IBizProductionResourceGroupSubPlanService;
import cn.ezhizao.project.business.takeStockPeriod.domain.BizTakeStockPeriod;
import cn.ezhizao.project.business.takeStockPeriod.service.IBizTakeStockPeriodService;
import cn.ezhizao.project.business.technologicalProcessDetail.domain.BizTechnologicalProcessDetail;
import cn.ezhizao.project.business.technologicalProcessDetail.service.IBizTechnologicalProcessDetailService;
import cn.ezhizao.project.business.turnover.domain.BizTurnover;
import cn.ezhizao.project.business.turnover.service.IBizTurnoverService;
import cn.ezhizao.project.system.domain.SysDept;
import cn.ezhizao.project.system.domain.SysDeptUser;
import cn.ezhizao.project.system.domain.SysUser;
import cn.ezhizao.project.system.mapper.SysDeptMapper;
import cn.ezhizao.project.system.mapper.SysUserMapper;
import cn.ezhizao.project.system.service.ISysConfigService;
import cn.ezhizao.project.system.service.ISysDeptUserService;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.server.ServerErrorException;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.math.BigDecimal;
import java.util.*;
import java.util.stream.Collectors;

/**
 * 报工记录Controller
 *
 * @author ezhizao
 * @date 2023-12-04
 */
@RestController
@RequestMapping("/business/dayworkItem")
public class BizDayworkItemController extends BaseController {
    @Resource
    private IBizDayworkItemService bizDayworkItemService;

    @Resource
    private IBizDayworkService bizDayworkService;
    @Resource
    HttpServletRequest request;

    @Resource
    private IBizDayworkCarrierService bizDayworkCarrierService;

    @Resource
    private IBizDayworkItemRejectService bizDayworkItemRejectService;

    @Resource
    private IBizProcessService processService;

    @Resource
    private IBizProductionResourceGroupDetailService bizProductionResourceGroupDetailService;
    @Resource
    private IBizProductionResourceGroupService bizProductionResourceGroupService;

    @Resource
    private ISysDeptUserService sysDeptUserService;

    @Resource
    private SysUserMapper sysUserMapper;

    @Resource
    private IBizTurnoverService bizTurnoverService;

    @Resource
    private IBizLotService bizLotService;


    @Resource
    private SysDeptMapper sysDeptMapper;

    @Resource
    private IBizProductionPlanDetailService bizProductionPlanDetailService;

    @Resource
    private IBizProductionResourceGroupSubPlanService bizProductionResourceGroupSubPlanService;
    @Resource
    private IBizLotTechnologicalProcessService bizLotTechnologicalProcessService;
    @Resource
    private IBizLotTechnologicalProcessDetailService bizLotTechnologicalProcessDetailService;
    @Resource
    private IBizTechnologicalProcessDetailService bizTechnologicalProcessDetailService;

    @Resource
    private IBizDeptProcessService bizDeptProcessService;
    @Resource
    private IBizDayworkItemExamineService bizDayworkItemExamineService;
    @Resource
    private IBizTakeStockPeriodService bizTakeStockPeriodService;
    @Resource
    private IBizOutsourcedOrderDetailProcessService bizOutsourcedOrderDetailProcessService;
    @Resource
    private ISysConfigService sysConfigService;

    /**
     * 查询报工记录列表
     */
//    @PreAuthorize("@ss.hasPermi('business:dayworkItem:list')")
    @GetMapping("/list")
    @Log(title = "查询报工记录", businessType = BusinessType.SELECT)
    public TableDataInfo list(BizDayworkItem bizDayworkItem) {
        //0420
        SysUser user = SecurityUtils.getLoginUser().getUser();
//        startPage();
        bizDayworkItem.setUserId(user.getUserId());
        List<BizDayworkItem> list = bizDayworkItemService.getList(bizDayworkItem);
        //如果是废品回用，ProcessSequence从新表拿
        if (bizDayworkItem.getIsAmend() == 1 || bizDayworkItem.getIsWasteRecycling() == 1) {
            BizLot bizLot = bizLotService.query().eq("id", bizDayworkItem.getLotId()).list().get(0);
            List<BizLotTechnologicalProcessDetail> bizTechnologicalWasteRecyclingDetails = bizLotTechnologicalProcessDetailService.query().eq("lot_technological_process_id", bizLot.getTechnologicalProcessId()).orderByAsc("process_step_number").list();
            BizLotTechnologicalProcessDetail lotTechnologicalProcessDetail = bizLotTechnologicalProcessDetailService.query().eq("id", list.get(0).getTechnologicalProcessDetailId()).one();
            BizTechnologicalProcessDetail bizTechnologicalProcessDetail = new BizTechnologicalProcessDetail();
            bizTechnologicalProcessDetail.setProcessId(lotTechnologicalProcessDetail.getProcessId());
            bizTechnologicalProcessDetail.setProcessAlias(lotTechnologicalProcessDetail.getProcessAlias());
            bizTechnologicalProcessDetail.setProcessStepNumber(lotTechnologicalProcessDetail.getProcessStepNumber());
            bizTechnologicalProcessDetail.setProcessCode(lotTechnologicalProcessDetail.getProcessCode());
            bizTechnologicalProcessDetail.setProductId(lotTechnologicalProcessDetail.getProductId());


            //查询所有工段下的工序
            List<BizDeptProcess> deptProcessList = bizDeptProcessService.query().list();
            List<BizProcess> processList = new ArrayList<>();
            for (BizLotTechnologicalProcessDetail bizTechnologicalWasteRecyclingDetail : bizTechnologicalWasteRecyclingDetails) {
                BizProcess process = new BizProcess();
                process.setId(bizTechnologicalWasteRecyclingDetail.getProcessId());
                process.setProcessCode(bizTechnologicalWasteRecyclingDetail.getProcessCode());
                process.setProcessStepNumber(bizTechnologicalWasteRecyclingDetail.getProcessStepNumber());
                process.setProcessAlias(bizTechnologicalWasteRecyclingDetail.getProcessAlias());
                process.setTechnologicalProcessDetailId(bizTechnologicalWasteRecyclingDetail.getId());
                process.setDeptProcess(deptProcessList.stream().filter(deptProcess -> deptProcess.getProcessId().equals(bizTechnologicalWasteRecyclingDetail.getProcessId())).collect(Collectors.toList()));
                processList.add(process);
            }
            list.stream().forEach(item -> {
                item.setProcessSequence(processList);
            });
            if (bizDayworkItem.getProcessStepNumber() != null) {
                list.forEach(item -> {
                    item.setProcess(
                            item.getProcessSequence().stream()
                                    .filter(process -> process.getProcessStepNumber().equals(bizDayworkItem.getProcessStepNumber()))
                                    .findFirst()
                                    .orElse(null) // 如果未找到匹配的 process，则设置为 null
                    );
                    item.setTechnologicalProcessDetail(bizTechnologicalProcessDetail);
                });
            }
        }
        //人员只能看到最近的一条报工记录中工序的报工
        List<BizDayworkItem> itemList = new ArrayList<>();
        String processStepNumber = "";
        if (list.size() > 0) {
            processStepNumber = list.get(0).getProcessStepNumber();
        }
        /** 根据当前工序查询下一道工序 */
        for (BizDayworkItem item : list) {
            for (int i = 0; i < item.getProcessSequence().size(); i++) {
                if ((i + 1) < item.getProcessSequence().size()) {
                    if (item.getProcessStepNumber().equals(item.getProcessSequence().get(i).getProcessStepNumber())) {

                        item.setNextProcess(item.getProcessSequence().get(i + 1));
                        //查询出非本工段的第一道序
                        for (BizDeptProcess deptProcess : item.getProcessSequence().get(i + 1).getDeptProcess()) {
                            if (!deptProcess.getDeptId().equals(item.getDeptId())) {
                                item.setNextDeptProcess(item.getNextProcess().getProcessAlias() + "、" + deptProcess.getProcessAlias());
                                break;
                            }
                        }
                    }
                }
            }
            // 设置上一工段,周转用
            List<BizDayworkItem> dayworkItemList = bizDayworkItemService.query().lt("status", 4).eq("lot_id", item.getLotId()).eq("process_step_number", item.getProcessStepNumber()).list();
            for (int i = 0; i < dayworkItemList.size(); i++) {
                if (dayworkItemList.get(i).getDeptName() != null && !"".equals(dayworkItemList.get(i).getDeptName())) {
                    item.setPreDeptName(dayworkItemList.get(i).getDeptName());
                    break;
                }
            }
            //只保留当前工序的报工记录
            if (processStepNumber.equals(item.getProcessStepNumber())) {
                itemList.add(item);
            }
        }

        return getDataTable(itemList);
    }

    @GetMapping("/assistList")
    @Log(title = "查询报工记录", businessType = BusinessType.SELECT)
    public TableDataInfo assistList(BizDayworkItem bizDayworkItem) {
        //0420
        List<BizDayworkItem> list = bizDayworkItemService.getAssistList(bizDayworkItem);
        //如果是废品回用，ProcessSequence从新表拿
        if (bizDayworkItem.getIsAmend() == 1 || bizDayworkItem.getIsWasteRecycling() == 1) {
            BizLot bizLot = bizLotService.query().eq("id", bizDayworkItem.getLotId()).list().get(0);
            List<BizLotTechnologicalProcessDetail> bizTechnologicalWasteRecyclingDetails = bizLotTechnologicalProcessDetailService.query().eq("lot_technological_process_id", bizLot.getTechnologicalProcessId()).orderByAsc("process_step_number").list();
            BizLotTechnologicalProcessDetail lotTechnologicalProcessDetail = bizLotTechnologicalProcessDetailService.query().eq("id", list.get(0).getTechnologicalProcessDetailId()).one();
            BizTechnologicalProcessDetail bizTechnologicalProcessDetail = new BizTechnologicalProcessDetail();
            bizTechnologicalProcessDetail.setProcessId(lotTechnologicalProcessDetail.getProcessId());
            bizTechnologicalProcessDetail.setProcessAlias(lotTechnologicalProcessDetail.getProcessAlias());
            bizTechnologicalProcessDetail.setProcessStepNumber(lotTechnologicalProcessDetail.getProcessStepNumber());
            bizTechnologicalProcessDetail.setProcessCode(lotTechnologicalProcessDetail.getProcessCode());
            bizTechnologicalProcessDetail.setProductId(lotTechnologicalProcessDetail.getProductId());


            //查询所有工段下的工序
            List<BizDeptProcess> deptProcessList = bizDeptProcessService.query().list();
            List<BizProcess> processList = new ArrayList<>();
            for (BizLotTechnologicalProcessDetail bizTechnologicalWasteRecyclingDetail : bizTechnologicalWasteRecyclingDetails) {
                BizProcess process = new BizProcess();
                process.setId(bizTechnologicalWasteRecyclingDetail.getProcessId());
                process.setProcessCode(bizTechnologicalWasteRecyclingDetail.getProcessCode());
                process.setProcessStepNumber(bizTechnologicalWasteRecyclingDetail.getProcessStepNumber());
                process.setProcessAlias(bizTechnologicalWasteRecyclingDetail.getProcessAlias());
                process.setTechnologicalProcessDetailId(bizTechnologicalWasteRecyclingDetail.getId());
                process.setDeptProcess(deptProcessList.stream().filter(deptProcess -> deptProcess.getProcessId().equals(bizTechnologicalWasteRecyclingDetail.getProcessId())).collect(Collectors.toList()));
                processList.add(process);
            }
            list.stream().forEach(item -> {
                item.setProcessSequence(processList);
            });
            if (bizDayworkItem.getProcessStepNumber() != null) {
                list.forEach(item -> {
                    item.setProcess(
                            item.getProcessSequence().stream()
                                    .filter(process -> process.getProcessStepNumber().equals(bizDayworkItem.getProcessStepNumber()))
                                    .findFirst()
                                    .orElse(null) // 如果未找到匹配的 process，则设置为 null
                    );
                    item.setTechnologicalProcessDetail(bizTechnologicalProcessDetail);
                });
            }
        }
        //人员只能看到最近的一条报工记录中工序的报工
        List<BizDayworkItem> itemList = new ArrayList<>();
        String processStepNumber = "";
        if (list.size() > 0) {
            processStepNumber = list.get(0).getProcessStepNumber();
        }
        /** 根据当前工序查询下一道工序 */
        for (BizDayworkItem item : list) {
            for (int i = 0; i < item.getProcessSequence().size(); i++) {
                if ((i + 1) < item.getProcessSequence().size()) {
                    if (item.getProcessStepNumber().equals(item.getProcessSequence().get(i).getProcessStepNumber())) {

                        item.setNextProcess(item.getProcessSequence().get(i + 1));
                        //查询出非本工段的第一道序
                        for (BizDeptProcess deptProcess : item.getProcessSequence().get(i + 1).getDeptProcess()) {
                            if (!deptProcess.getDeptId().equals(item.getDeptId())) {
                                item.setNextDeptProcess(item.getNextProcess().getProcessAlias() + "、" + deptProcess.getProcessAlias());
                                break;
                            }
                        }
                    }
                }
            }
            // 设置上一工段,周转用
            List<BizDayworkItem> dayworkItemList = bizDayworkItemService.query().lt("status", 4).eq("lot_id", item.getLotId()).eq("process_step_number", item.getProcessStepNumber()).list();
            for (int i = 0; i < dayworkItemList.size(); i++) {
                if (dayworkItemList.get(i).getDeptName() != null && !"".equals(dayworkItemList.get(i).getDeptName())) {
                    item.setPreDeptName(dayworkItemList.get(i).getDeptName());
                    break;
                }
            }
            //只保留当前工序的报工记录
            if (processStepNumber.equals(item.getProcessStepNumber())) {
                itemList.add(item);
            }
        }

        return getDataTable(itemList);
    }


    /**
     * 查询当前是否为首序
     */
    @Log(title = "查询当前是否为首序", businessType = BusinessType.SELECT)
    @GetMapping(value = "/getIsFirstOrder/{dayWorkId}")
    public AjaxResult getIsFirstOrder(@PathVariable("dayWorkId") Long dayWorkId) {
        HashMap<String, Object> map = new HashMap<>();
        //根据dayWorkId查询出当前工序的报工记录(按照工序筛选每道工序只查询一条数据)
        List<BizDayworkItem> list = bizDayworkItemService.getItemScreen(dayWorkId);
        //查询出来的数据等于1条则为首序
        if (list.size() == 1) {
            map.put("isFirstOrder", true);
        } else {
            map.put("isFirstOrder", false);
        }
        return success(map);
    }

    @GetMapping("/listItem")
    @Log(title = "查询员工绑定设备组列表", businessType = BusinessType.SELECT)
    public TableDataInfo listItem(BizDayworkItem bizDayworkItem) {
        QueryWrapper<BizDayworkItem> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq("status", bizDayworkItem.getStatus()).eq("daywork_id", bizDayworkItem.getDayworkId());
        List<BizDayworkItem> list = bizDayworkItemService.list(queryWrapper);

        list.forEach(item -> {
            QueryWrapper<BizDayworkItemReject> wrapper = new QueryWrapper<>();
            wrapper.eq("daywork_item_id", item.getId());
            List<BizDayworkItemReject> rejectList = bizDayworkItemRejectService.list(wrapper);
            int sum = 0;
            for (int i = 0; i < rejectList.size(); i++) {
                sum += rejectList.get(i).getRejectNum();
            }
            item.setRejectSum(sum);
        });
        return getDataTable(list);
    }

    @GetMapping("/getDayWorkItemHistory")
    @Log(title = "查询报工历史", businessType = BusinessType.SELECT)
    public TableDataInfo getDayWorkItemHistory(String startTime, String endTime) {

        startTime = startTime + " 00:00:00";
        endTime = endTime + " 23:59:59";
        Long tenantId = Long.parseLong(request.getHeader("tenantId"));
        List<BizDayworkItem> list = bizDayworkItemService.getDayWorkItemHistory(startTime, endTime, SecurityUtils.getLoginUser().getUser().getUserName(),tenantId);
        return getDataTable(list);
    }
    @GetMapping("/getDayWorkItemFinishHistory")
    @Log(title = "查询已完成报工历史", businessType = BusinessType.SELECT)
    public AjaxResult getDayWorkItemFinishHistory(String startTime, String endTime) {
        startTime = startTime + " 00:00:00";
        endTime = endTime + " 23:59:59";
        Long tenantId = Long.parseLong(request.getHeader("tenantId"));
        List<BizDayworkItem> list = bizDayworkItemService.getDayWorkItemHistory(startTime, endTime, SecurityUtils.getLoginUser().getUser().getUserName(),tenantId);
        if(!list.isEmpty()){
            List<BizDayworkItem> finishedList = list.stream().filter(item -> item.getStatus().equals("3")).collect(Collectors.toList());
            if(!finishedList.isEmpty()){
                List<BizDayworkItem> newList = new ArrayList<>();
                for(BizDayworkItem item : finishedList){
                    BizDayworkItem bizDayworkItem = new BizDayworkItem();
                    List<BizDayworkItem> collect = list.stream().filter(l -> l.getDayworkId().equals(item.getDayworkId()) && l.getProcessStepNumber().equals(item.getProcessStepNumber())).collect(Collectors.toList());
                    bizDayworkItem.setProcessAlias(item.getProcess().getProcessAlias());
                    bizDayworkItem.setEquipmentDetailCode(collect.stream().map(BizDayworkItem::getEquipmentDetailCode).filter(code -> code != null && !code.equals("undefined")&& !code.equals(""))
                            .distinct()
                            .collect(Collectors.joining(",")));
                    bizDayworkItem.setLotCode(item.getLotCode());
                    bizDayworkItem.setProductDescription(item.getProductDescription());
                    bizDayworkItem.setDayworkId(item.getDayworkId());
                    bizDayworkItem.setDaywork(item.getDaywork());
                    bizDayworkItem.setProcessId(item.getProcessId());
                    bizDayworkItem.setProcessStepNumber(item.getProcessStepNumber());
                    bizDayworkItem.setQualifiedNum(collect.stream().map(BizDayworkItem::getQualifiedNum).mapToInt(Integer::intValue).sum());
                    bizDayworkItem.setRejectNum(collect.stream().map(BizDayworkItem::getRejectNum).mapToInt(Integer::intValue).sum());
                    bizDayworkItem.setEndTime(item.getEndTime());
                    bizDayworkItem.setAdoptStatus(item.getAdoptStatus());
                    newList.add(bizDayworkItem);
                }
                return success(newList);
            }
        }
        return success();
    }

    /**
     * 查询报工记录列表
     */
//    @PreAuthorize("@ss.hasPermi('business:dayworkItem:list')")
    @GetMapping("/tonoverList")
    @Log(title = "查询周转记录", businessType = BusinessType.SELECT)
    public TableDataInfo tonoverList(BizDayworkItem bizDayworkItem) throws NoSuchFieldException, IllegalAccessException {
//       setTenantId(bizDayworkItem);
        List<BizDayworkItem> list = bizDayworkItemService.getList(bizDayworkItem);
        //人员只能看到最近的一条报工记录中工序的报工
        List<BizDayworkItem> itemList = new ArrayList<>();
        Long processId = 0L;
        if (!list.isEmpty()) {
            processId = list.get(0).getProcessId();
        }
        if (!list.isEmpty()) {
            List<Long> technologicalIds = list.stream().filter(item -> item.getIsAmend() == 1 || item.getIsWasteRecycling() == 1).map(BizDayworkItem::getTechnologicalProcessId).collect(Collectors.toList());
            List<BizLotTechnologicalProcessDetail> bizLotTechnologicalProcessDetailList = bizLotTechnologicalProcessDetailService.query().in("lot_technological_process_id", technologicalIds.isEmpty() ? Collections.singletonList(0L) : list.stream().filter(item -> item.getIsAmend() == 1 || item.getIsWasteRecycling() == 1).map(BizDayworkItem::getTechnologicalProcessId).collect(Collectors.toList())).list();
            List<Long> processIds = bizLotTechnologicalProcessDetailList.stream().map(BizLotTechnologicalProcessDetail::getProcessId).distinct().collect(Collectors.toList());
            List<BizDeptProcess> deptProcessList = bizDeptProcessService.query().in("process_id", processIds.isEmpty() ? Collections.singletonList(0L) : processIds).list();
            list.forEach(info -> {
                if (info.getTurnoverType().equals("1")) {
                    info.setTurnoverArea(info.getPlace());
                }
                List<BizProcess> tempList = new ArrayList<>();
                if (info.getIsAmend() == 1 || info.getIsWasteRecycling() == 1) {
                    List<BizLotTechnologicalProcessDetail> infoList = bizLotTechnologicalProcessDetailList.stream().filter(l -> l.getLotTechnologicalProcessId().equals(info.getTechnologicalProcessId())).collect(Collectors.toList());
                    infoList.forEach(l -> {
                        BizProcess process = new BizProcess();
                        List<BizDeptProcess> deptProcesses = deptProcessList.stream().filter(d -> d.getProcessId().equals(l.getProcessId())).collect(Collectors.toList());
                        process.setProcessAlias(l.getProcessAlias());
                        process.setProcessCode(l.getProcessCode());
                        process.setId(l.getProcessId());
                        process.setProcessStepNumber(l.getProcessStepNumber());
                        process.setDeptProcess(deptProcesses);
                        tempList.add(process);
                    });
                    info.setProcessSequence(tempList);
                }
            });
        }
        /** 根据当前工序查询下一道工序 */
        for (BizDayworkItem item : list) {
            for (int i = 0; i < item.getProcessSequence().size(); i++) {
                if ((i + 1) < item.getProcessSequence().size()) {
                    if (item.getProcessId().equals(item.getProcessSequence().get(i).getId()) && item.getProcessStepNumber().equals(item.getProcessSequence().get(i).getProcessStepNumber())) {

                        item.setNextProcess(item.getProcessSequence().get(i + 1));
                        //查询出非本工段的第一道序
                        for (BizDeptProcess deptProcess : item.getProcessSequence().get(i + 1).getDeptProcess()) {
                            if (!deptProcess.getDeptId().equals(item.getDeptId())) {
                                item.setNextDeptProcess(item.getNextProcess().getProcessAlias() + "、" + deptProcess.getProcessAlias());
                                break;
                            }
                        }
                    }
                }
            }
            // 设置上一工段,周转用
            List<BizDayworkItem> dayworkItemList = bizDayworkItemService.query().eq("lot_id", item.getLotId()).eq("process_id", item.getProcessId()).lt("create_time", item.getCreateTime()).orderByDesc("create_time").last("limit 1").list();
            // List<BizDayworkItem> dayworkItemList = bizDayworkItemService.query().lt("status", 4).eq("lot_id", item.getLotId()).eq("process_id", item.getProcessId()).list();

            for (int i = 0; i < dayworkItemList.size(); i++) {
                if (dayworkItemList.get(i).getDeptName() != null && !"".equals(dayworkItemList.get(i).getDeptName())) {
                    item.setPreDeptName(dayworkItemList.get(i).getDeptName());
                    break;
                }
            }
            //只保留当前工序的报工记录
//            if (processId.equals(item.getProcessId())){
            itemList.add(item);
        }
//        }

        return getDataTable(itemList);
    }

    /**
     * 导出报工记录列表
     */
//    @PreAuthorize("@ss.hasPermi('business:dayworkItem:export')")
    @Log(title = "导出报工记录列表", businessType = BusinessType.EXPORT)
    @PostMapping("/export")
    public void export(HttpServletResponse response, BizDayworkItem bizDayworkItem) throws NoSuchFieldException, IllegalAccessException {
        List<BizDayworkItem> list = bizDayworkItemService.getList(bizDayworkItem);
        ExcelUtil<BizDayworkItem> util = new ExcelUtil<BizDayworkItem>(BizDayworkItem.class);
        util.exportExcel(response, list, "报工记录数据");
    }

    @PostMapping("/getInnerTurnoverByDeptId")
    @Log(title = "查询工段内部周转", businessType = BusinessType.SELECT)
    public AjaxResult getInnerTurnoverByDeptId(@RequestBody BizDayworkItem bizDayworkItem) throws NoSuchFieldException, IllegalAccessException {
        setTenantId(bizDayworkItem);
        List<BizDaywork> dayworkList = bizDayworkItemService.getInnerListByDeptId(bizDayworkItem);
        if (!dayworkList.isEmpty()) {
            List<Long> dayworkIds = dayworkList.stream().map(BizDaywork::getId).collect(Collectors.toList());
            //正常批次的工序集合
            List<Long> normalTechnologicalProcessIds = dayworkList.stream().filter(item -> item.getIsWasteRecycling() == 0 && item.getIsAmend() == 0).map(BizDaywork::getTechnologicalProcessId).collect(Collectors.toList());
            List<BizTechnologicalProcessDetail> normalDetailList = bizTechnologicalProcessDetailService.query().ne("tenant_id", 9).in("technological_process_id", normalTechnologicalProcessIds.isEmpty() ? Collections.singletonList(0L) : normalTechnologicalProcessIds).orderByAsc("process_step_number").list();
            //不正常批次的工序集合
            List<Long> abNormalTechnologicalProcessIds = dayworkList.stream().filter(item -> item.getIsWasteRecycling() == 1 || item.getIsAmend() == 1).map(BizDaywork::getTechnologicalProcessId).collect(Collectors.toList());
            List<BizLotTechnologicalProcessDetail> abNormalDetailList = bizLotTechnologicalProcessDetailService.query().in("lot_technological_process_id", abNormalTechnologicalProcessIds.isEmpty() ? Collections.singletonList(0L) : abNormalTechnologicalProcessIds).orderByAsc("process_step_number").list();
            List<BizDayworkItem> dayworkItemList = bizDayworkItemService.query().in("daywork_id", dayworkIds).list();
            dayworkList.forEach(daywork -> {
                List<BizDayworkItem> dayworkItem = dayworkItemList.stream().filter(item -> item.getDayworkId().equals(daywork.getId())).sorted(Comparator.comparing(BizDayworkItem::getCreateTime).reversed()).collect(Collectors.toList());
                String lastProcessStepNumber = dayworkItem.get(0).getProcessStepNumber();
                //当前工序报工信息
                List<BizDayworkItem> lastDayworkItem = dayworkItem.stream().filter(item -> item.getProcessStepNumber().equals(lastProcessStepNumber) && (item.getStatus().equals("2") || item.getStatus().equals("3"))).collect(Collectors.toList());
                //合格数量求和
                daywork.setTemporaryProcessQualifiedNum(lastDayworkItem.stream().mapToInt(BizDayworkItem::getQualifiedNum).sum());
                //周转的报工信息
                BizDayworkItem turnoverItem = dayworkItem.stream().filter(item -> item.getProcessStepNumber().equals(lastProcessStepNumber) && item.getStatus().equals("4")).collect(Collectors.toList()).get(0);
                daywork.setDayworkItemList(new ArrayList<BizDayworkItem>() {{
                    add(turnoverItem);
                }});
                //周转位置
                daywork.setPlace(turnoverItem.getPlace());
                //设置操作者
                daywork.setCreatorName(turnoverItem.getNickName());
                List<BizProcess> processSequence = new ArrayList<>();
                //工序集合
                if (daywork.getIsAmend() == 1 || daywork.getIsWasteRecycling() == 1) {
                    BizProcess process = new BizProcess();
                    BizLotTechnologicalProcessDetail processDetail = abNormalDetailList.stream().filter(item -> item.getProcessStepNumber().equals(turnoverItem.getProcessStepNumber()) && item.getLotTechnologicalProcessId().equals(turnoverItem.getTechnologicalProcessId())).collect(Collectors.toList()).get(0);
                    process.setProcessAlias(processDetail.getProcessAlias());
                    process.setProcessStepNumber(processDetail.getProcessStepNumber());
                    daywork.setCurrentProcess(process);
                    List<BizLotTechnologicalProcessDetail> collectList = abNormalDetailList.stream().filter(item -> item.getLotTechnologicalProcessId().equals(daywork.getTechnologicalProcessId())).collect(Collectors.toList());
                    for (BizLotTechnologicalProcessDetail detail : collectList) {
                        BizProcess newProcess = new BizProcess();
                        newProcess.setId(detail.getProcessId());
                        newProcess.setProcessCode(detail.getProcessCode());
                        newProcess.setProcessAlias(detail.getProcessAlias());
                        newProcess.setTechnologicalProcessDetailId(detail.getId());
                        newProcess.setProcessStepNumber(detail.getProcessStepNumber());
                        processSequence.add(newProcess);
                    }
                    daywork.setProcessSequence(processSequence);
                } else {
                    BizProcess process = new BizProcess();
                    BizTechnologicalProcessDetail processDetail = normalDetailList.stream().filter(item -> item.getProcessStepNumber().equals(turnoverItem.getProcessStepNumber()) && item.getTechnologicalProcessId().equals(turnoverItem.getTechnologicalProcessId())).collect(Collectors.toList()).get(0);
                    process.setProcessAlias(processDetail.getProcessAlias());
                    process.setProcessStepNumber(processDetail.getProcessStepNumber());
                    daywork.setCurrentProcess(process);
                    List<BizTechnologicalProcessDetail> collectList = normalDetailList.stream().filter(item -> item.getTechnologicalProcessId().equals(daywork.getTechnologicalProcessId())).collect(Collectors.toList());
                    for (BizTechnologicalProcessDetail detail : collectList) {
                        BizProcess newProcess = new BizProcess();
                        newProcess.setId(detail.getProcessId());
                        newProcess.setProcessCode(detail.getProcessCode());
                        newProcess.setProcessAlias(detail.getProcessAlias());
                        newProcess.setProcessStepNumber(detail.getProcessStepNumber());
                        newProcess.setTechnologicalProcessDetailId(detail.getId());
                        processSequence.add(newProcess);
                    }
                    daywork.setProcessSequence(processSequence);
                }
            });
        }
        return success(dayworkList);
    }

    @PostMapping("/updateDayworkItemInnerTurnover")
    @Log(title = "保存内部周转", businessType = BusinessType.SELECT)
    public AjaxResult updateDayworkItemInnerTurnover(@RequestBody List<BizDayworkItem> bizDayworkItem) {
        bizDayworkItem.forEach(item -> {
            item.setIsInnerTurnover(1);
        });

        return success(bizDayworkItemService.updateBatchById(bizDayworkItem));
    }

    @PostMapping("/getOutTurnoverByDeptId")
    @Log(title = "查询工段外部周转", businessType = BusinessType.SELECT)
    public AjaxResult getOutTurnoverByDeptId(@RequestBody BizDayworkItem bizDayworkItem) {
        List<BizDaywork> dayworkList = bizDayworkItemService.getOutListByDeptId(bizDayworkItem);
        if (!dayworkList.isEmpty()) {
            List<Long> dayworkIds = dayworkList.stream().map(BizDaywork::getId).collect(Collectors.toList());
            //正常批次的工序集合
            List<Long> normalTechnologicalProcessIds = dayworkList.stream().filter(item -> item.getIsWasteRecycling() == 0 && item.getIsAmend() == 0).map(BizDaywork::getTechnologicalProcessId).collect(Collectors.toList());
            List<BizTechnologicalProcessDetail> normalDetailList = bizTechnologicalProcessDetailService.query().ne("tenant_id", 9).in("technological_process_id", normalTechnologicalProcessIds.isEmpty() ? Collections.singletonList(0L) : normalTechnologicalProcessIds).orderByAsc("process_step_number").list();
            //不正常批次的工序集合
            List<Long> abNormalTechnologicalProcessIds = dayworkList.stream().filter(item -> item.getIsWasteRecycling() == 1 || item.getIsAmend() == 1).map(BizDaywork::getTechnologicalProcessId).collect(Collectors.toList());
            List<BizLotTechnologicalProcessDetail> abNormalDetailList = bizLotTechnologicalProcessDetailService.query().in("lot_technological_process_id", abNormalTechnologicalProcessIds.isEmpty() ? Collections.singletonList(0L) : abNormalTechnologicalProcessIds).orderByAsc("process_step_number").list();
            List<BizDayworkItem> dayworkItemList = bizDayworkItemService.query().in("daywork_id", dayworkIds).list();
            dayworkList.forEach(daywork -> {
                List<BizDayworkItem> dayworkItem = dayworkItemList.stream().filter(item -> item.getDayworkId().equals(daywork.getId())).sorted(Comparator.comparing(BizDayworkItem::getCreateTime).reversed()).collect(Collectors.toList());
                String lastProcessStepNumber = dayworkItem.get(0).getProcessStepNumber();
                //当前工序报工信息
                List<BizDayworkItem> lastDayworkItem = dayworkItem.stream().filter(item -> item.getProcessStepNumber().equals(lastProcessStepNumber) && (item.getStatus().equals("2") || item.getStatus().equals("3"))).collect(Collectors.toList());
                //合格数量求和
                daywork.setTemporaryProcessQualifiedNum(lastDayworkItem.stream().mapToInt(BizDayworkItem::getQualifiedNum).sum());
                //周转的报工信息
                BizDayworkItem turnoverItem = dayworkItem.stream().filter(item -> item.getProcessStepNumber().equals(lastProcessStepNumber) && item.getStatus().equals("4")).collect(Collectors.toList()).get(0);
                daywork.setDayworkItemList(new ArrayList<BizDayworkItem>() {{
                    add(turnoverItem);
                }});
                //周转位置
                daywork.setPlace(turnoverItem.getTurnoverArea());
                //设置操作者
                daywork.setCreatorName(turnoverItem.getNickName());
                List<BizProcess> processSequence = new ArrayList<>();
                //工序集合
                if (daywork.getIsAmend() == 1 || daywork.getIsWasteRecycling() == 1) {
                    BizProcess process = new BizProcess();
                    BizLotTechnologicalProcessDetail processDetail = abNormalDetailList.stream().filter(item -> item.getProcessStepNumber().equals(turnoverItem.getProcessStepNumber())).collect(Collectors.toList()).get(0);
                    process.setProcessAlias(processDetail.getProcessAlias());
                    process.setProcessStepNumber(processDetail.getProcessStepNumber());
                    daywork.setCurrentProcess(process);
                    for (BizLotTechnologicalProcessDetail detail : abNormalDetailList) {
                        BizProcess newProcess = new BizProcess();
                        newProcess.setId(detail.getProcessId());
                        newProcess.setProcessCode(detail.getProcessCode());
                        newProcess.setProcessAlias(detail.getProcessAlias());
                        newProcess.setTechnologicalProcessDetailId(detail.getId());
                        newProcess.setProcessStepNumber(detail.getProcessStepNumber());
                        processSequence.add(newProcess);
                    }
                    daywork.setProcessSequence(processSequence);
                } else {
                    BizProcess process = new BizProcess();
                    BizTechnologicalProcessDetail processDetail = normalDetailList.stream().filter(item -> item.getProcessStepNumber().equals(turnoverItem.getProcessStepNumber())).collect(Collectors.toList()).get(0);
                    process.setProcessAlias(processDetail.getProcessAlias());
                    process.setProcessStepNumber(processDetail.getProcessStepNumber());
                    daywork.setCurrentProcess(process);
                    for (BizTechnologicalProcessDetail detail : normalDetailList) {
                        BizProcess newProcess = new BizProcess();
                        newProcess.setId(detail.getProcessId());
                        newProcess.setProcessCode(detail.getProcessCode());
                        newProcess.setProcessAlias(detail.getProcessAlias());
                        newProcess.setProcessStepNumber(detail.getProcessStepNumber());
                        newProcess.setTechnologicalProcessDetailId(detail.getId());
                        processSequence.add(newProcess);
                    }
                    daywork.setProcessSequence(processSequence);
                }
            });
        }
        return success(dayworkList);
    }

    /**
     * 获取报工记录详细信息
     */
//    @PreAuthorize("@ss.hasPermi('business:dayworkItem:query')")
    @GetMapping(value = "/{id}")
    @Log(title = "查询报工记录详细信息", businessType = BusinessType.SELECT)
    public AjaxResult getInfo(@PathVariable("id") Long id) {
        return success(bizDayworkItemService.getById(id));
    }

    /**
     * 查询当前批次完成状态
     */
    @GetMapping(value = "/startStatus")
    @Log(title = "查询当前批次完成状态", businessType = BusinessType.SELECT)
    public AjaxResult startStatus(BizDayworkItem bizDayworkItem) {
        List<BizDayworkItem> dayworkItemList = bizDayworkItemService.query()
                .eq("daywork_id", bizDayworkItem.getDayworkId()).orderByDesc("create_time").list();
        if (!dayworkItemList.isEmpty()) {
            String processStepNumber = dayworkItemList.get(0).getProcessStepNumber();
            List<BizDayworkItem> list = bizDayworkItemService.query()
                    .eq("daywork_id", bizDayworkItem.getDayworkId())
                    .eq("process_step_number", processStepNumber)
                    .eq("process_id", bizDayworkItem.getProcessId()).eq("status", 3).list();
            if (list.size() > 0) {

                return success(true);

            }
        }

        return success(false);
    }

    /**
     * 根据载具获得待周转信息，
     * 用于周转时，显示 从哪个工段，到哪个工段
     */
    @GetMapping(value = "/getDayworkItemByCarrier")
    @Log(title = "根据载具获得待周转信息", businessType = BusinessType.SELECT)
    public AjaxResult getDayworkItemByCarrier(BizDayworkItem bizDayworkItem) {
        List<BizDayworkItem> dayworkItemByCarriers = bizDayworkItemService.getDayworkItemByCarrier(bizDayworkItem);

        for (BizDayworkItem dayworkItemByCarrier : dayworkItemByCarriers) {
            BizProcess byId = processService.getById(dayworkItemByCarrier.getProcessId());
            dayworkItemByCarrier.setNextProcess(byId);

            // 设置上一工段,周转用
            List<BizDayworkItem> dayworkItemList = bizDayworkItemService.query().lt("status", 4).eq("lot_id", dayworkItemByCarrier.getLotId()).eq("process_id", dayworkItemByCarrier.getProcessId()).list();
            for (int i = 0; i < dayworkItemList.size(); i++) {
                if (dayworkItemList.get(i).getDeptName() != null && !"".equals(dayworkItemList.get(i).getDeptName())) {
                    dayworkItemByCarrier.setPreDeptName(dayworkItemList.get(i).getDeptName());
                    break;
                }
            }
        }
        return success(dayworkItemByCarriers);
    }

    // 箱码规则修改后，二维码中存的是箱码。所以增加了这个方法
    @GetMapping(value = "/getDayworkItemByCarrierCode")
    @Log(title = "根据载具获取报工信息", businessType = BusinessType.SELECT)
    public AjaxResult getDayworkItemByCarrierCode(BizDayworkItem bizDayworkItem) {
        List<BizDayworkItem> dayworkItemByCarriers = bizDayworkItemService.getDayworkItemByCarrierCode(bizDayworkItem);

        for (BizDayworkItem dayworkItemByCarrier : dayworkItemByCarriers) {
            BizProcess byId = processService.getById(dayworkItemByCarrier.getProcessId());
            dayworkItemByCarrier.setNextProcess(byId);

            // 设置上一工段,周转用
            List<BizDayworkItem> dayworkItemList = bizDayworkItemService.query().lt("status", 4).eq("lot_id", dayworkItemByCarrier.getLotId()).eq("process_id", dayworkItemByCarrier.getProcessId()).list();
            for (int i = 0; i < dayworkItemList.size(); i++) {
                if (dayworkItemList.get(i).getDeptName() != null && !"".equals(dayworkItemList.get(i).getDeptName())) {
                    dayworkItemByCarrier.setPreDeptName(dayworkItemList.get(i).getDeptName());
                    break;
                }
            }
        }
        return success(dayworkItemByCarriers);
    }

    /**
     * 新增报工记录
     */
//    @PreAuthorize("@ss.hasPermi('business:dayworkItem:add')")
    @Log(title = "新增报工记录", businessType = BusinessType.INSERT)
    @Transactional
    @PostMapping
    public AjaxResult add(@RequestBody BizDayworkItem bizDayworkItem) throws NoSuchFieldException, IllegalAccessException {
        // 设置工时

        /** 如果是已完成工序，生成一条空报工记录保存下一道工序 */
        BizDaywork daywork = new BizDaywork();
        daywork.setId(bizDayworkItem.getDayworkId());

        List<BizDaywork> list = bizDayworkService.getList(daywork);
        daywork = list.get(0);

        //如果是修改工单，则获取该工单工序
        if (daywork.getIsAmend() == 1 || daywork.getIsWasteRecycling() == 1) {
            List<BizProcess> processList = new ArrayList<>();
            List<BizLotTechnologicalProcessDetail> bizLotTechnologicalProcessDetail = bizLotTechnologicalProcessDetailService.query().eq("lot_technological_process_id", daywork.getTechnologicalProcessId()).list();
            bizLotTechnologicalProcessDetail.forEach(item -> {
                BizProcess itemProcess = new BizProcess();
                itemProcess.setProcessCode(item.getProcessCode());
                itemProcess.setProcessAlias(item.getProcessAlias());
                itemProcess.setProcessStepNumber(item.getProcessStepNumber());
                processList.add(itemProcess);
            });
            daywork.setProcessSequence(processList);
        } else {
            List<BizProcess> processList = new ArrayList<>();
            List<BizTechnologicalProcessDetail> bizTechnologicalProcessDetail = bizTechnologicalProcessDetailService.query().eq("technological_process_id", daywork.getTechnologicalProcessId()).ne("tenant_id", 9).list();
            bizTechnologicalProcessDetail.forEach(item -> {
                BizProcess itemProcess = new BizProcess();
                itemProcess.setProcessCode(item.getProcessCode());
                itemProcess.setProcessAlias(item.getProcessAlias());
                itemProcess.setProcessStepNumber(item.getProcessStepNumber());
                processList.add(itemProcess);
            });
            daywork.setProcessSequence(processList);
        }

        if (daywork.getIsAmend() == 1) {
            bizDayworkItem.setFormDayworkItemId(1L);
        }
        //并且计算该报工批次的当前工序下的合格数总量
        BizDayworkItem bizItem = new BizDayworkItem();
        bizItem.setDayworkId(bizDayworkItem.getDayworkId());
        bizItem.setProcessId(bizDayworkItem.getProcessId());
        bizItem.setTechnologicalProcessDetailId(bizDayworkItem.getTechnologicalProcessDetailId());
        List<BizDayworkItem> itemList = bizDayworkItemService.getList(bizItem);
        //获取当前工序下的总合格数
        Integer lot = 0;
        //如果非手续
        if (bizDayworkItem.getQualifiedNum() != null) {
            lot = bizDayworkItem.getQualifiedNum();
        }
        for (BizDayworkItem dayworkItem : itemList) {
            lot += dayworkItem.getQualifiedNum();
        }
        // 结束报工校验
        //如果是手续(上一道序的合格数是0)校验报工批次的单批数
        if ((bizDayworkItem.getStatus().equals("2") || bizDayworkItem.getStatus().equals("3")) && !bizDayworkItem.getIsPreProcess()) {
            if (daywork.getProcessQualifiedNum() == 0) {
                if (lot > (daywork.getOneLotQuantity() * 1.03)) {
                    return error("该批次合格数已超投入数上限(103%)");
                }
            } else {
                if (lot > (daywork.getProcessQualifiedNum() * 1.03)) {
                    return error("该批次合格数已超投入数上限(103%)");
                }
            }
        }

        // 已送达状态更改daywork的当前部门
        if (bizDayworkItem.getStatus().equals("7")) {
            daywork.setDeptId(bizDayworkItem.getDeptId());
            daywork.setProcessQualifiedNum(daywork.getTemporaryProcessQualifiedNum());
            daywork.setProtemProcessStepNumber(bizDayworkItem.getProcessStepNumber());
            bizDayworkService.updateById(daywork);
            // 如果被邀请人不是本工段内的人，则需要从当前资源组中删除被邀请人
            bizProductionResourceGroupDetailService.deleTemporanyPeople(daywork);
        }

        if (bizDayworkItem.getStatus().equals("5")) {
            daywork.setProcessQualifiedNum(daywork.getTemporaryProcessQualifiedNum());
            bizDayworkService.updateById(daywork);
            daywork.setProtemProcessStepNumber(bizDayworkItem.getProcessStepNumber());
            // 如果被邀请人不是本工段内的人，则需要从当前资源组中删除被邀请人
            bizProductionResourceGroupDetailService.deleTemporanyPeople(daywork);
        }
        /** 当最后一道序完成时，释放该批次下所有载具 */
        if (bizDayworkItem.getStatus().equals("3")) {
            //校验当前序是否还有未完成的报工
            List<BizDayworkItem> items = bizDayworkItemService.query().eq("daywork_id", bizDayworkItem.getDayworkId()).eq("process_id", bizDayworkItem.getProcessId()).lt("status", 2).ne("id", bizDayworkItem.getId()).list();
            if (!items.isEmpty()) {
                return error("当前工序还有其他未完成的报工，不允许工序完成");
            }
            //工序结束时将合格数保存
            daywork.setProtemProcessId(bizDayworkItem.getProcessId());
            //daywork.setTemporaryProcessQualifiedNum(lot);
            // 此处在biz_daywork_qualified中间表中，插入一条数据
            // 记录当前批次，当前工序的投入数、合格数


            //判断当前序为最后一道序
            if (bizDayworkItem.getProcessStepNumber().equals(daywork.getProcessSequence().get(daywork.getProcessSequence().size() - 1).getProcessStepNumber())) {
                bizDayworkCarrierService.removeByDayworkId(daywork.getId());
                //最后一道序的时候，把daywork表的status设置为2
                daywork.setStatus(2);
            }
            bizDayworkService.updateById(daywork);
        }
        //如果没有合格数，则投产数量为总数量，上道序的合格数为下到序的投产数
        if (daywork.getProcessQualifiedNum() == 0) {
            bizDayworkItem.setProdNum(daywork.getProductionQuantity());
        } else {
            bizDayworkItem.setProdNum(daywork.getProcessQualifiedNum());
        }
        // 现在等于4的时候就要能扫码开始批次,所以要设置一下部门pc查询计划单分配活
//        if(bizDayworkItem.getStatus().equals("4")){
//            daywork.setDeptId(bizDayworkItem.getDeptId());
//            bizDayworkService.updateById(daywork);
//        }
        bizDayworkItem.setLotId(daywork.getLotId());
        bizDayworkItem.setLotCode(daywork.getLotCode());
        SysUser user = SecurityUtils.getLoginUser().getUser();
//        bizDayworkItem.setUserId(user.getUserId());
//        bizDayworkItem.setUserName(user.getUserName());
//        bizDayworkItem.setNickName(user.getNickName());
        String[] statusArr = {"0", "4", "5", "7"};
        if (Arrays.asList(statusArr).contains(bizDayworkItem.getStatus())) {
            bizDayworkItem.setWorkingHours(0L);
        } else {
            bizDayworkItem.setWorkingHours(bizDayworkItem.getEndTime().getTime() - bizDayworkItem.getStartTime().getTime());
        }
        boolean batch = bizDayworkItemService.saveOrUpdate(bizDayworkItem);
        if(!batch){
            throw new RuntimeException("保存失败，请刷新后重试");
        }
        //先保存item再保存废品原因
        if ("2".equals(bizDayworkItem.getStatus()) || "3".equals(bizDayworkItem.getStatus())) {
            for (BizDayworkItemReject item : bizDayworkItem.getRejectList()) {
                item.setDayworkItemId(bizDayworkItem.getId());
                item.setDayworkId(bizDayworkItem.getDayworkId());
                item.setLotId(bizDayworkItem.getLotId());
                item.setDeptId(bizDayworkItem.getDeptId());
                item.setProcessId(bizDayworkItem.getProcessId());
            }
        }

        //保存箱数
        List<BizDayworkItem> bizDayworkItems = new ArrayList<>();
        bizDayworkItems.add(bizDayworkItem);
        bizDayworkItemService.saveCarrierNum(bizDayworkItems);


        // 自动派活
        SysDept sysDept = sysDeptMapper.selectDeptById(bizDayworkItem.getDeptId());
        if (sysDept.getAutoAllocation() == 1) {
            // 查资源组
            List<BizProductionResourceGroup> productionResourceGroupList = bizProductionResourceGroupService.list(new QueryWrapper<BizProductionResourceGroup>().eq("dept_id", bizDayworkItem.getDeptId()));

            //查询是否已经分配资源组
            BizProductionResourceGroupSubPlan groupSubPlan = new BizProductionResourceGroupSubPlan();
            groupSubPlan.setDeptId(bizDayworkItem.getDeptId());
            groupSubPlan.setProductionPlanDetailId(bizDayworkItem.getProductionPlanDetailId());
            List<BizProductionResourceGroupSubPlan> groupSubPlanList = bizProductionResourceGroupSubPlanService.getList(groupSubPlan);
            //如果没分配
            if (groupSubPlanList.isEmpty()) {
                //查产品id
                BizProductionPlanDetail productionPlanDetail = bizProductionPlanDetailService.getOne(new QueryWrapper<BizProductionPlanDetail>().eq("id", bizDayworkItem.getProductionPlanDetailId()));
                //存放保存的subPlanList
                List<BizProductionResourceGroupSubPlan> subPlanList = new ArrayList<>();
                for (BizProductionResourceGroup info : productionResourceGroupList) {
                    BizProductionResourceGroupSubPlan subPlan = new BizProductionResourceGroupSubPlan();
                    subPlan.setProductId(productionPlanDetail.getProductId());
                    subPlan.setProductionPlanDetailId(bizDayworkItem.getProductionPlanDetailId());
                    subPlan.setTechnologicalProcessId(bizDayworkItem.getTechnologicalProcessId());
                    subPlan.setResourceGroupId(info.getId());
                    subPlan.setDeptId(bizDayworkItem.getDeptId());
                    subPlan.setResourceGroupCode(info.getCode());
                    subPlanList.add(subPlan);
                }
                bizProductionResourceGroupSubPlanService.saveBatch(subPlanList);
            }

        }
        bizDayworkItemRejectService.saveBatch(bizDayworkItem.getRejectList());
        return toAjax(batch);

    }

    @Log(title = "新增报工记录", businessType = BusinessType.INSERT)
    @Transactional
    @PostMapping("/saveInnerDayworkItem")
    public AjaxResult saveInnerDayworkItem(@RequestBody BizDayworkItem bizDayworkItem) throws NoSuchFieldException, IllegalAccessException {
        /** 如果是已完成工序，生成一条空报工记录保存下一道工序 */
        BizDaywork daywork = new BizDaywork();
        daywork.setId(bizDayworkItem.getDayworkId());

        List<BizDaywork> list = bizDayworkService.getList(daywork);
        daywork = list.get(0);

        //如果是修改工单，则获取该工单工序
        if (daywork.getIsAmend() == 1 || daywork.getIsWasteRecycling() == 1) {
            List<BizProcess> processList = new ArrayList<>();
            List<BizLotTechnologicalProcessDetail> bizLotTechnologicalProcessDetail = bizLotTechnologicalProcessDetailService.query().eq("lot_technological_process_id", daywork.getTechnologicalProcessId()).list();
            bizLotTechnologicalProcessDetail.forEach(item -> {
                BizProcess itemProcess = new BizProcess();
                itemProcess.setProcessCode(item.getProcessCode());
                itemProcess.setProcessAlias(item.getProcessAlias());
                itemProcess.setProcessStepNumber(item.getProcessStepNumber());
                processList.add(itemProcess);
            });
            daywork.setProcessSequence(processList);
        } else {
            List<BizProcess> processList = new ArrayList<>();
            List<BizTechnologicalProcessDetail> bizTechnologicalProcessDetail = bizTechnologicalProcessDetailService.query().eq("technological_process_id", daywork.getTechnologicalProcessId()).ne("tenant_id", 9).list();
            bizTechnologicalProcessDetail.forEach(item -> {
                BizProcess itemProcess = new BizProcess();
                itemProcess.setProcessCode(item.getProcessCode());
                itemProcess.setProcessAlias(item.getProcessAlias());
                itemProcess.setProcessStepNumber(item.getProcessStepNumber());
                processList.add(itemProcess);
            });
            daywork.setProcessSequence(processList);
        }

        if (daywork.getIsAmend() == 1) {
            bizDayworkItem.setFormDayworkItemId(1L);
        }
        //并且计算该报工批次的当前工序下的合格数总量
        BizDayworkItem bizItem = new BizDayworkItem();
        bizItem.setDayworkId(bizDayworkItem.getDayworkId());
        bizItem.setProcessId(bizDayworkItem.getProcessId());
        bizItem.setTechnologicalProcessDetailId(bizDayworkItem.getTechnologicalProcessDetailId());
        List<BizDayworkItem> itemList = bizDayworkItemService.getList(bizItem);
        //获取当前工序下的总合格数
        Integer lot = 0;
        //如果非手续
        if (bizDayworkItem.getQualifiedNum() != null) {
            lot = bizDayworkItem.getQualifiedNum();
        }
        for (BizDayworkItem dayworkItem : itemList) {
            lot += dayworkItem.getQualifiedNum();
        }
        // 结束报工校验
        //如果是手续(上一道序的合格数是0)校验报工批次的单批数
        if ((bizDayworkItem.getStatus().equals("2") || bizDayworkItem.getStatus().equals("3")) && !bizDayworkItem.getIsPreProcess()) {
            if (daywork.getProcessQualifiedNum() == 0) {
                if (lot > (daywork.getOneLotQuantity() * 1.03)) {
                    return error("该批次合格数已超投入数上限(103%)");
                }
            } else {
                if (lot > (daywork.getProcessQualifiedNum() * 1.03)) {
                    return error("该批次合格数已超投入数上限(103%)");
                }
            }
        }

        // 已送达状态更改daywork的当前部门
        if (bizDayworkItem.getStatus().equals("7")) {
            daywork.setDeptId(bizDayworkItem.getDeptId());
            daywork.setProcessQualifiedNum(daywork.getTemporaryProcessQualifiedNum());
            daywork.setProtemProcessStepNumber(bizDayworkItem.getProcessStepNumber());
            bizDayworkService.updateById(daywork);
        }

        if (bizDayworkItem.getStatus().equals("5")) {
            daywork.setProcessQualifiedNum(daywork.getTemporaryProcessQualifiedNum());
            bizDayworkService.updateById(daywork);
            daywork.setProtemProcessStepNumber(bizDayworkItem.getProcessStepNumber());
        }
        /** 当最后一道序完成时，释放该批次下所有载具 */
        if (bizDayworkItem.getStatus().equals("3")) {
            //校验当前序是否还有未完成的报工
            List<BizDayworkItem> items = bizDayworkItemService.query().eq("daywork_id", bizDayworkItem.getDayworkId()).eq("process_id", bizDayworkItem.getProcessId()).lt("status", 2).ne("id", bizDayworkItem.getId()).list();
            if (!items.isEmpty()) {
                return error("当前工序还有其他未完成的报工，不允许工序完成");
            }
            //工序结束时将合格数保存
            daywork.setProtemProcessId(bizDayworkItem.getProcessId());
            //daywork.setTemporaryProcessQualifiedNum(lot);
            // 此处在biz_daywork_qualified中间表中，插入一条数据
            // 记录当前批次，当前工序的投入数、合格数


            //判断当前序为最后一道序
            if (bizDayworkItem.getProcessStepNumber().equals(daywork.getProcessSequence().get(daywork.getProcessSequence().size() - 1).getProcessStepNumber())) {
                bizDayworkCarrierService.removeByDayworkId(daywork.getId());
                //最后一道序的时候，把daywork表的status设置为2
                daywork.setStatus(2);
            }
            bizDayworkService.updateById(daywork);
            //修改发出单报工合格数，投产数及折损率
            BizOutsourcedOrderDetailProcess outsourcedOrderDetailProcess = bizOutsourcedOrderDetailProcessService.query().eq("daywork_id", bizDayworkItem.getDayworkId()).eq("process_step_number", bizDayworkItem.getProcessStepNumber()).one();
            outsourcedOrderDetailProcess.setProductionNum(bizDayworkItem.getProdNum());
            List<BizDayworkItem> currentDayworkItem = bizDayworkItemService.query().eq("daywork_id", bizDayworkItem.getDayworkId()).eq("process_step_number", bizDayworkItem.getProcessStepNumber()).in("status", Arrays.asList("2", "3")).list();
            int sum = currentDayworkItem.stream().mapToInt(BizDayworkItem::getQualifiedNum).sum() + bizDayworkItem.getQualifiedNum();
            outsourcedOrderDetailProcess.setQualifiedNum(sum);
            float percent = ((outsourcedOrderDetailProcess.getProductionNum() - outsourcedOrderDetailProcess.getQualifiedNum()) / (float) outsourcedOrderDetailProcess.getProductionNum()) * 100;
            if (percent < 0) {
                return error("合格数量不能大于投产数量。");
            }
            outsourcedOrderDetailProcess.setLoss(BigDecimal.valueOf(percent));
            outsourcedOrderDetailProcess.setStatus(1);
            bizOutsourcedOrderDetailProcessService.updateById(outsourcedOrderDetailProcess);
        }
        //如果没有合格数，则投产数量为总数量，上道序的合格数为下到序的投产数
        if (daywork.getProcessQualifiedNum() == 0) {
            bizDayworkItem.setProdNum(daywork.getProductionQuantity());
        } else {
            bizDayworkItem.setProdNum(daywork.getProcessQualifiedNum());
        }
        // 现在等于4的时候就要能扫码开始批次,所以要设置一下部门pc查询计划单分配活
//        if(bizDayworkItem.getStatus().equals("4")){
//            daywork.setDeptId(bizDayworkItem.getDeptId());
//            bizDayworkService.updateById(daywork);
//        }
        bizDayworkItem.setLotId(daywork.getLotId());
        bizDayworkItem.setLotCode(daywork.getLotCode());
        SysUser user = SecurityUtils.getLoginUser().getUser();
        bizDayworkItem.setUserId(user.getUserId());
        bizDayworkItem.setUserName(user.getUserName());
        bizDayworkItem.setNickName(user.getNickName());
        String[] statusArr = {"0", "4", "5", "7"};
        if (Arrays.asList(statusArr).contains(bizDayworkItem.getStatus())) {
            bizDayworkItem.setWorkingHours(0L);
        } else {
            bizDayworkItem.setWorkingHours(bizDayworkItem.getEndTime().getTime() - bizDayworkItem.getStartTime().getTime());
        }
        boolean batch = bizDayworkItemService.saveOrUpdate(bizDayworkItem);
        //先保存item再保存废品原因
        if ("2".equals(bizDayworkItem.getStatus()) || "3".equals(bizDayworkItem.getStatus())) {
            for (BizDayworkItemReject item : bizDayworkItem.getRejectList()) {
                item.setDayworkItemId(bizDayworkItem.getId());
                item.setDayworkId(bizDayworkItem.getDayworkId());
                item.setLotId(bizDayworkItem.getLotId());
                item.setDeptId(bizDayworkItem.getDeptId());
                item.setProcessId(bizDayworkItem.getProcessId());
            }
        }

        //保存箱数
        List<BizDayworkItem> bizDayworkItems = new ArrayList<>();
        bizDayworkItems.add(bizDayworkItem);
        bizDayworkItemService.saveCarrierNum(bizDayworkItems);


        // 自动派活
        SysDept sysDept = sysDeptMapper.selectDeptById(bizDayworkItem.getDeptId());
        if (sysDept.getAutoAllocation() == 1) {
            // 查资源组
            List<BizProductionResourceGroup> productionResourceGroupList = bizProductionResourceGroupService.list(new QueryWrapper<BizProductionResourceGroup>().eq("dept_id", bizDayworkItem.getDeptId()));

            //查询是否已经分配资源组
            BizProductionResourceGroupSubPlan groupSubPlan = new BizProductionResourceGroupSubPlan();
            groupSubPlan.setDeptId(bizDayworkItem.getDeptId());
            groupSubPlan.setProductionPlanDetailId(bizDayworkItem.getProductionPlanDetailId());
            List<BizProductionResourceGroupSubPlan> groupSubPlanList = bizProductionResourceGroupSubPlanService.getList(groupSubPlan);
            //如果没分配
            if (groupSubPlanList.isEmpty()) {
                //查产品id
                BizProductionPlanDetail productionPlanDetail = bizProductionPlanDetailService.getOne(new QueryWrapper<BizProductionPlanDetail>().eq("id", bizDayworkItem.getProductionPlanDetailId()));
                //存放保存的subPlanList
                List<BizProductionResourceGroupSubPlan> subPlanList = new ArrayList<>();
                for (BizProductionResourceGroup info : productionResourceGroupList) {
                    BizProductionResourceGroupSubPlan subPlan = new BizProductionResourceGroupSubPlan();
                    subPlan.setProductId(productionPlanDetail.getProductId());
                    subPlan.setProductionPlanDetailId(bizDayworkItem.getProductionPlanDetailId());
                    subPlan.setTechnologicalProcessId(bizDayworkItem.getTechnologicalProcessId());
                    subPlan.setResourceGroupId(info.getId());
                    subPlan.setDeptId(bizDayworkItem.getDeptId());
                    subPlan.setResourceGroupCode(info.getCode());
                    subPlanList.add(subPlan);
                }
                bizProductionResourceGroupSubPlanService.saveBatch(subPlanList);
            }

        }
        bizDayworkItemRejectService.saveBatch(bizDayworkItem.getRejectList());
        return toAjax(batch);

    }

    /**
     * 批量修改报工记录
     */
//    @PreAuthorize("@ss.hasPermi('business:dayworkItem:add')")
    @Log(title = "批量修改报工记录", businessType = BusinessType.INSERT)
    @Transactional
    @PutMapping("/updateBatch")
    public AjaxResult updateBatch(@RequestBody List<BizDayworkItem> bizDayworkItem) throws NoSuchFieldException, IllegalAccessException {
        SysUser user = SecurityUtils.getLoginUser().getUser();
        List<Long> ids = new ArrayList<>();
        for (BizDayworkItem item : bizDayworkItem) {
            if (item.getStatus().equals("5")) {
                BizDaywork daywork = new BizDaywork();
                daywork.setId(item.getDayworkId());
                daywork = bizDayworkService.getList(daywork).get(0);
                daywork.setDeptId(item.getDeptId());
                //daywork.setProcessQualifiedNum(daywork.getTemporaryProcessQualifiedNum());
                // 此处在biz_daywork_qualified中间表中，插入一条数据
                // 记录当前批次，当前工序的投入数、合格数

                bizDayworkService.updateById(daywork);
                item.setRecipientId(user.getUserId());
                ids.add(item.getId());
            } else if (item.getStatus().equals("7")) {
                BizDaywork daywork = new BizDaywork();
                daywork.setId(item.getDayworkId());
                daywork = bizDayworkService.getList(daywork).get(0);
                daywork.setDeptId(item.getDeptId());
                //daywork.setProcessQualifiedNum(daywork.getTemporaryProcessQualifiedNum());
                // 此处在biz_daywork_qualified中间表中，插入一条数据
                // 记录当前批次，当前工序的投入数、合格数

                bizDayworkService.updateById(daywork);
                item.setRecipientId(user.getUserId());
                ids.add(item.getId());
                BizTurnover turnover = bizTurnoverService.getOne(new QueryWrapper<BizTurnover>().eq("dept_id", item.getDeptId()).eq("status", 9));
                //0629placeId为字符属性
                item.setPlaceId(turnover.getId() + "");
                item.setPlace(turnover.getCode());
            } else {
                item.setUserId(user.getUserId());
                item.setUserName(user.getUserName());
                item.setNickName(user.getNickName());
                ids.add(item.getId());
            }
        }
        List<BizDayworkItem> oldList = bizDayworkItemService.query().in("id", ids).list();

        return toAjax(saveOrUpdateBatch(bizDayworkItemService, bizDayworkItem, oldList));
    }

    @PutMapping("/updateBatchBack")
    @Log(title = "周转取消送达", businessType = BusinessType.SELECT)
    public AjaxResult updateBatchBack(@RequestBody List<BizDayworkItem> bizDayworkItem) throws NoSuchFieldException, IllegalAccessException {
        List list = new ArrayList<>();
        for (int i = 0; i < bizDayworkItem.size(); i++) {
            list.add(bizDayworkItem.get(i));
            SysUser user = sysUserMapper.selectUserById(bizDayworkItem.get(i).getCreatorId());
            bizDayworkItem.get(i).setNickName(user.getNickName());
        }
        return toAjax(saveOrUpdateBatch(bizDayworkItemService, bizDayworkItem, list));
    }

    /**
     * 批量新增报工记录
     */
//    @PreAuthorize("@ss.hasPermi('business:dayworkItem:add')")
    @Log(title = "批量新增报工记录", businessType = BusinessType.INSERT)
    @Transactional
    @PostMapping("/saveBatch")
    public AjaxResult saveBatch(@RequestBody BizDayworkItem bizDayworkItem) throws NoSuchFieldException, IllegalAccessException {
        //        String tenantId = request.getHeader("tenantId");
        BizDaywork daywork = bizDayworkService.getById(bizDayworkItem.getDayworkId());
        if (daywork.getIsAmend() == 1) {
            bizDayworkItem.setFormDayworkItemId(1l);
        }
        SysUser user = SecurityUtils.getLoginUser().getUser();
        bizDayworkItem.setUserId(user.getUserId());
        bizDayworkItem.setUserName(user.getUserName());
        bizDayworkItem.setNickName(user.getNickName());
//          bizDayworkItem.setTenantId(Long.valueOf(tenantId));
        boolean b = bizDayworkItemService.saveOrUpdate(bizDayworkItem);
        if (!bizDayworkItem.getCollaborationList().isEmpty()) {
            for (BizDayworkItemCollaboration collaboration : bizDayworkItem.getCollaborationList()) {
                collaboration.setDayworkId(bizDayworkItem.getDayworkId());
                collaboration.setDayworkItemId(bizDayworkItem.getId());
                collaboration.insert();
            }
        }
        // 判断开始报工的批次在不在滚筒,如果在开始报工后制动鼓解绑载具
        SysDept dept = sysDeptMapper.selectDeptById(bizDayworkItem.getDeptId());
        if (dept.getAutoUnbind() == 1) {
            List<BizDayworkCarrier> oldList = bizDayworkCarrierService.query().eq("daywork_id", bizDayworkItem.getDayworkId()).eq("process_inspection_id", 0L).eq("is_changed", 0).list();
            List<BizDayworkCarrier> newList = oldList.stream().collect(Collectors.toList());
            newList.forEach(item -> item.setIsChanged(1));
            bizDayworkCarrierService.updateBatchById(newList);
//            saveOrUpdateCarrierBatch(bizDayworkCarrierService, newList, oldList);
        }
        return toAjax(b);
    }

    @Log(title = "批量新增报工记录", businessType = BusinessType.INSERT)
    @Transactional
    @PostMapping("/saveAssistBatch")
    public AjaxResult saveAssistBatch(@RequestBody BizDayworkItem bizDayworkItem) throws NoSuchFieldException, IllegalAccessException {
        //        String tenantId = request.getHeader("tenantId");
        BizDaywork daywork = bizDayworkService.getById(bizDayworkItem.getDayworkId());
        if (daywork.getIsAmend() == 1) {
            bizDayworkItem.setFormDayworkItemId(1l);
        }
        SysUser user = SecurityUtils.getLoginUser().getUser();
        bizDayworkItem.setUserId(user.getUserId());
        bizDayworkItem.setUserName(user.getUserName());
        bizDayworkItem.setNickName(user.getNickName());
//          bizDayworkItem.setTenantId(Long.valueOf(tenantId));
        boolean b = bizDayworkItemService.saveOrUpdate(bizDayworkItem);
        if (!bizDayworkItem.getCollaborationList().isEmpty()) {
            for (BizDayworkItemCollaboration collaboration : bizDayworkItem.getCollaborationList()) {
                collaboration.setDayworkId(bizDayworkItem.getDayworkId());
                collaboration.setDayworkItemId(bizDayworkItem.getId());
                collaboration.insert();
            }
        }
        // 判断开始报工的批次在不在滚筒,如果在开始报工后制动鼓解绑载具
        SysDept dept = sysDeptMapper.selectDeptById(bizDayworkItem.getDeptId());
        if (dept.getAutoUnbind() == 1) {
            List<BizDayworkCarrier> oldList = bizDayworkCarrierService.query().eq("daywork_id", bizDayworkItem.getDayworkId()).eq("process_inspection_id", 0L).eq("is_changed", 0).list();
            List<BizDayworkCarrier> newList = oldList.stream().collect(Collectors.toList());
            newList.forEach(item -> item.setIsChanged(1));
            bizDayworkCarrierService.updateBatchById(newList);
//            saveOrUpdateCarrierBatch(bizDayworkCarrierService, newList, oldList);
        }
        return toAjax(b);
    }

    @PostMapping("/getDayworkItemByDayworkId")
    @Log(title = "获取报工明细", businessType = BusinessType.INSERT)
    public AjaxResult getDayworkItemByDayworkId(@RequestBody BizDayworkItem bizDayworkItem) {
        List<BizDayworkItem> list = bizDayworkItemService.getListByDayworkId(bizDayworkItem);
        return success(list);
    }

    @PostMapping("/getSortItemByDayworkId")
    @Log(title = "获取分选报工明细", businessType = BusinessType.INSERT)
    public AjaxResult getSortItemByDayworkId(@RequestBody BizDayworkItem bizDayworkItem) {
        List<BizDayworkItem> list = bizDayworkItemService.getSortListByDayworkId(bizDayworkItem);
        return success(list);
    }

    /**
     * 临时报工
     */
//    @PreAuthorize("@ss.hasPermi('business:dayworkItem:add')")
    @Log(title = "临时报工记录", businessType = BusinessType.INSERT)
    @Transactional
    @PostMapping("/proTem")
    public AjaxResult proTem(@RequestBody List<BizProductionResourceGroupDetail> details) {
        //查询出当前批次
        BizDaywork queryDaywork = new BizDaywork();
        queryDaywork.setId(details.get(0).getProtemDayworkId());

        SysUser user = SecurityUtils.getLoginUser().getUser();
        Long currentUserId = user.getUserId();

        BizDaywork daywork = bizDayworkService.getList(queryDaywork).get(0);
        List<BizDayworkItem> allDayworkItems = new ArrayList<>();
        BizDayworkItem latest = null;
        if (daywork != null) {
            allDayworkItems = bizDayworkItemService.query().eq("daywork_id", daywork.getId()).list();
            // 根据当前的dayworkId，获取相应的daywork_item集合，并根据创建日期进行倒叙排序
            List<BizDayworkItem> currentDayworkItems = allDayworkItems.stream()
                    .filter(di -> di.getDayworkId().equals(daywork.getId()) && di.getUserId().equals(currentUserId))
                    .sorted(Comparator.comparing(BizDayworkItem::getCreateTime).reversed())
                    .collect(Collectors.toList());

            // 获取最后一条报工明细
            latest = currentDayworkItems.get(0);
        }

        //如果没找到自己的报工数据最后一条，提示
        if (latest == null) {
            return error("未匹配到最后一条报工信息");
        }

        //协作者是否在部门人员里，如果没有，添加
        QueryWrapper<SysDeptUser> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq("dept_id", details.get(0).getDeptId());
        queryWrapper.eq("deleted", 0);
        queryWrapper.eq("is_temporary", 0);
        List<SysDeptUser> deptUserList = sysDeptUserService.list(queryWrapper);
        List<Long> ids = new ArrayList<>();
        List<Long> userIds = new ArrayList<>();
        for (SysDeptUser deptUser : deptUserList) {
            ids.add(deptUser.getUserId());
        }
        for (BizProductionResourceGroupDetail detail : details) {
            userIds.add(detail.getCommonId());
        }
        List<SysDeptUser> detail = new ArrayList<>();
        for (Long userId : userIds) {
            if (!ids.contains(userId)) {
                SysDeptUser deptUser = new SysDeptUser();
                deptUser.setTenantId(details.get(0).getTenantId());
                deptUser.setDeptId(details.get(0).getDeptId());
                deptUser.setUserId(userId);
                deptUser.setIsTemporary(details.get(0).getProtemDayworkId());
                detail.add(deptUser);
            }
        }
        sysDeptUserService.saveBatch(detail);
        //该协作者添加到该工段的资源组明细
//        QueryWrapper<BizProductionResourceGroupDetail> wrapper = new QueryWrapper<>();
//        wrapper.eq("dept_id",details.get(0).getDeptId());
//        wrapper.eq("production_resource_group_id",details.get(0).getProductionResourceGroupId());
//        wrapper.eq("deleted",0);
//        wrapper.eq("common_type","person");
//        List<BizProductionResourceGroupDetail> productionResourceGroupDetailList = bizProductionResourceGroupDetailService.list(wrapper);
//        List<Long> productionResourceGroupDetailIds = new ArrayList<>();
//        for (BizProductionResourceGroupDetail productionResourceGroupDetail : productionResourceGroupDetailList) {
//            productionResourceGroupDetailIds.add(productionResourceGroupDetail.getCommonId());
//        }
//        List<BizProductionResourceGroupDetail> newList = new ArrayList<>();

        // 0223 不选择资源组，将邀请人的当前工段所有的资源组都分配给被邀请人
        List<BizProductionResourceGroup> groupList = bizProductionResourceGroupService.query().eq("dept_id", details.get(0).getDeptId()).list();
        List<Long> groupIds = new ArrayList<>();
        for (BizProductionResourceGroup group : groupList) {
            groupIds.add(group.getId());
        }
        List<Long> groups = new ArrayList<>();
        //0415修改为通过ProtemDayworkId查询，如果有这个批次的临时资源组，则只把临时的资源组赋给被邀请人，而不是邀请人所有的资源组；如果没有这个批次的临时资源组，则把邀请人的所有资源组赋给被邀请人
        List<BizProductionResourceGroupDetail> protemList = bizProductionResourceGroupDetailService.query()
                .eq("common_id", SecurityUtils.getLoginUser().getUser().getUserId())
                .in("production_resource_group_id", groupIds).
                eq("protem_daywork_id",details.get(0).getProtemDayworkId()).list();
        if(!protemList.isEmpty()){
            for (BizProductionResourceGroupDetail item : protemList) {
                groups.add(item.getProductionResourceGroupId());
            }
        }else {
            //查询出当前用户在该工段的所有资源组
            List<BizProductionResourceGroupDetail> list = bizProductionResourceGroupDetailService.query().eq("common_id", SecurityUtils.getLoginUser().getUser().getUserId()).eq("protem_daywork_id", 0L).in("production_resource_group_id", groupIds).list();
            for (BizProductionResourceGroupDetail item : list) {
                groups.add(item.getProductionResourceGroupId());
            }
        }
        List<BizDayworkItem> newItemList = new ArrayList<>();
        List<BizProductionResourceGroupDetail> newDetails = new ArrayList<>();
        //遍历的邀请者的差集是否大于0
        Boolean flag = false;
        for (BizProductionResourceGroupDetail item : details) {
            // 查询被邀请人在该工段所有的资源组
            // 20240712 之前是只要该资源组原来有这个人员不管是不是邀请的就不加了，改成这个人员假设是邀请报工人员要再加一次。
            List<BizProductionResourceGroupDetail> inviteList = bizProductionResourceGroupDetailService.query().eq("common_id", item.getCommonId()).eq("protem_daywork_id", item.getProtemDayworkId()).in("production_resource_group_id", groupIds).list();
            List<Long> inviteGroups = new ArrayList<>();
            for (BizProductionResourceGroupDetail inviteItem : inviteList) {
                inviteGroups.add(inviteItem.getProductionResourceGroupId());
            }
            // 20240712 防止重复邀请判断
            if (inviteList.stream().anyMatch(e -> e.getProtemDayworkId().equals(item.getProtemDayworkId()) && e.getProtemProcessId().equals(item.getProtemProcessId()) && e.getProtemProcessStepNumber().equals(item.getProtemProcessStepNumber()))) {
                throw new ServiceException("请勿重复邀请相同员工。");
            }
            //存放当前用户和被邀请人员资源组的差集
            List<Long> filterGroupIds = new ArrayList<>();
            for (Long group : groups) {
                if (!inviteGroups.contains(group)) {
                    filterGroupIds.add(group);
                }
            }
            //把被邀请人加进每个资源组
            if (!filterGroupIds.isEmpty()) {
                flag = true;
                for (Long id : filterGroupIds) {
                    BizProductionResourceGroupDetail newDetail = new BizProductionResourceGroupDetail();
                    newDetail.setCommonId(item.getCommonId());
                    newDetail.setCommonName(item.getCommonName());
                    newDetail.setCommonCode(item.getCommonCode());
                    newDetail.setCommonType(item.getCommonType());
                    newDetail.setProtemDayworkId(item.getProtemDayworkId());
                    newDetail.setProtemProcessId(item.getProtemProcessId());
                    newDetail.setProtemProcessStepNumber(item.getProtemProcessStepNumber());
                    newDetail.setDeptId(item.getDeptId());
                    // 设置 productionResourceGroupId 属性为当前的 id
                    newDetail.setProductionResourceGroupId(id);
                    newDetails.add(newDetail);
                }

                //保存一条未开始的报工


            }
            /** 添加一条报工批次时生成一条未开始的Item */
            BizDayworkItem bizDayworkItem = new BizDayworkItem();
            bizDayworkItem.setDayworkId(daywork.getId());
            bizDayworkItem.setLotId(daywork.getLotId());
            bizDayworkItem.setUserId(item.getCommonId());
            bizDayworkItem.setUserName(item.getCommonCode());
            bizDayworkItem.setNickName(item.getCommonName());
            bizDayworkItem.setProcessStepNumber(latest.getProcessStepNumber());
            bizDayworkItem.setProdNum(latest.getProdNum());
            bizDayworkItem.setTechnologicalProcessId(latest.getTechnologicalProcessId());
            bizDayworkItem.setProductionPlanDetailId(latest.getProductionPlanDetailId());
            bizDayworkItem.setTechnologicalProcessDetailId(item.getTechnologicalProcessDetailId());
            //0114 这里要把前段显示的item的processId传进来
            bizDayworkItem.setProcessId(daywork.getCurrentProcess().getId());
            bizDayworkItem.setDeptName(latest.getDeptName());
            bizDayworkItem.setDeptId(details.get(0).getDeptId());
            newItemList.add(bizDayworkItem);
        }
        //}
        if (flag) {
            bizDayworkItemService.saveBatch(newItemList);
            boolean batch = bizProductionResourceGroupDetailService.saveBatch(newDetails);

            return toAjax(batch);
        } else {
            return success(bizDayworkItemService.saveBatch(newItemList));
        }
    }

    // @PreAuthorize("@ss.hasPermi('business:dayworkItem:add')")
    @Log(title = "报工记录", businessType = BusinessType.INSERT)
    @PostMapping("/replacing")
    public AjaxResult replacing(@RequestBody BizDayworkItem bizDayworkItem) throws NoSuchFieldException, IllegalAccessException {
        return toAjax(bizDayworkItemService.save(bizDayworkItem));
    }

    /**
     * 修改报工记录
     */
    // @PreAuthorize("@ss.hasPermi('business:dayworkItem:edit')")
    @Log(title = "修改报工记录", businessType = BusinessType.UPDATE)
    @PutMapping
    public AjaxResult edit(@RequestBody BizDayworkItem bizDayworkItem) throws NoSuchFieldException, IllegalAccessException {
//        String tenantId = request.getHeader("tenantId");
//        bizDayworkItem.setTenantId(Long.valueOf(tenantId));
        return toAjax(bizDayworkItemService.updateById(bizDayworkItem));
    }

    /**
     * 删除报工记录
     */
//    @PreAuthorize("@ss.hasPermi('business:dayworkItem:remove')")
    @Log(title = "删除报工记录", businessType = BusinessType.DELETE)
    @DeleteMapping("/{ids}")
    public AjaxResult remove(@PathVariable List<Long> ids) {
        return toAjax(bizDayworkItemService.removeBatchByIds(ids));
    }

    @PostMapping("/addEquipmentInfo")
    @Log(title = "新增分选设备信息", businessType = BusinessType.SELECT)
    public AjaxResult addEquipmentInfo(@RequestBody BizDayworkItem bizDayworkItem) {
        bizDayworkItemService.updateById(bizDayworkItem);
        return success();
    }

    //修改周转信息
    @Transactional
    @PutMapping("/updateTurnoverInfo")
    @Log(title = "修改周转信息", businessType = BusinessType.INSERT)
    public AjaxResult updateTurnoverInfo(@RequestBody BizDayworkItem bizDayworkItem) throws NoSuchFieldException, IllegalAccessException {
        //查到需要修改的周转信息
        BizDayworkItem dayworkItem = bizDayworkItemService.query().eq("daywork_id", bizDayworkItem.getDayworkId())
                .eq("process_step_number", bizDayworkItem.getProcessStepNumber())
                .eq("status", 4).list().get(0);
        //车间外周转
        dayworkItem.setDeptId(bizDayworkItem.getDeptId());
        dayworkItem.setDeptName(bizDayworkItem.getDeptName());
        bizDayworkItemService.updateById(dayworkItem);
        //修改daywork表信息
        BizDaywork daywork = bizDayworkService.query().eq("id", bizDayworkItem.getDayworkId()).list().get(0);
        daywork.setDeptId(dayworkItem.getDeptId());
        bizDayworkService.updateById(daywork);
        // 自动派活
        SysDept sysDept = sysDeptMapper.selectDeptById(dayworkItem.getDeptId());
        if (sysDept.getAutoAllocation() == 1) {
            // 查资源组
            List<BizProductionResourceGroup> productionResourceGroupList = bizProductionResourceGroupService.list(new QueryWrapper<BizProductionResourceGroup>().eq("dept_id", bizDayworkItem.getDeptId()).eq("is_deactivate", 0));

            //查询是否已经分配资源组
            BizProductionResourceGroupSubPlan groupSubPlan = new BizProductionResourceGroupSubPlan();
            groupSubPlan.setDeptId(bizDayworkItem.getDeptId());
            groupSubPlan.setProductionPlanDetailId(daywork.getProductionPlanDetailId());

            List<BizProductionResourceGroupSubPlan> groupSubPlanList = bizProductionResourceGroupSubPlanService.getAotList(groupSubPlan);
            //如果没分配
            if (groupSubPlanList.size() == 0) {
                //查产品id
                BizProductionPlanDetail productionPlanDetail = bizProductionPlanDetailService.getOne(new QueryWrapper<BizProductionPlanDetail>().eq("id", daywork.getProductionPlanDetailId()));
                //存放保存的subPlanList
                List<BizProductionResourceGroupSubPlan> subPlanList = new ArrayList<>();
                for (BizProductionResourceGroup info : productionResourceGroupList) {
                    BizProductionResourceGroupSubPlan subPlan = new BizProductionResourceGroupSubPlan();
                    subPlan.setProductId(productionPlanDetail.getProductId());
                    subPlan.setProductionPlanDetailId(daywork.getProductionPlanDetailId());
                    subPlan.setTechnologicalProcessId(daywork.getTechnologicalProcessId());
                    subPlan.setResourceGroupId(info.getId());
                    subPlan.setDeptId(bizDayworkItem.getDeptId());
                    subPlan.setResourceGroupCode(info.getCode());
                    subPlanList.add(subPlan);
                }
                bizProductionResourceGroupSubPlanService.saveBatch(subPlanList);
            }

        }

        return success();
    }

    /***       外协周转。暂时注释       ***/
    @Log(title = "外协周转申请")
    @Transactional
    @PostMapping("/turnoverOutsource")
    public AjaxResult turnoverOutsource(@RequestBody BizDayworkItem bizDayworkItem) throws NoSuchFieldException, IllegalAccessException {
        setTenantId(bizDayworkItem);
        //判断当前是否在盘点
        BizTakeStockPeriod bizTakeStockPeriod = bizTakeStockPeriodService.query().eq("status", 1).one();
        if (bizTakeStockPeriod != null && bizTakeStockPeriod.getStatus() == 1) {
            return error("当前在盘点，禁止投产");
        }
        // 设置工时
        // 获取箱子关联的所有批次
        boolean batch = true;
        SysDept sysDept =new SysDept();
          sysDept = sysDeptMapper.selectDeptByCodeAndTenantId(bizDayworkItem.getDeptCode(), bizDayworkItem.getTenantId());

        bizDayworkItem.setDeptId(sysDept.getDeptId());
        bizDayworkItem.setDeptName(sysDept.getDeptName());
        List<BizDayworkCarrier> dayworkCarriers = bizDayworkCarrierService.query().eq("process_inspection_id", 0L).eq("is_changed", 0).eq("daywork_id", bizDayworkItem.getDayworkId()).list();
        List<BizDayworkCarrier> allCarries = bizDayworkCarrierService.query().eq("is_changed", 0).eq("process_inspection_id", 0L).in("carrier_id", dayworkCarriers.isEmpty() ? Collections.singletonList(0L) : dayworkCarriers.stream().map(BizDayworkCarrier::getCarrierId).collect(Collectors.toList())).list();
        // 关联批次的所有最后一条报工
        List<BizDayworkItem> bizDayworkItems = bizDayworkItemService.query().in("daywork_id", allCarries.isEmpty() ? Collections.singletonList(0L) : allCarries.stream().map(BizDayworkCarrier::getDayworkId).collect(Collectors.toList())).in("status", Arrays.asList("0", "1", "2", "3")).orderByDesc("status").orderByDesc("create_time").list();
        List<BizDayworkItem> bizDayworkItemAll = bizDayworkItemService.query().in("daywork_id", allCarries.isEmpty() ? Collections.singletonList(0L) : allCarries.stream().map(BizDayworkCarrier::getDayworkId).collect(Collectors.toList())).orderByDesc("create_time").list();
        List<BizDayworkItem> bizDayworkItemList = bizDayworkItemService.query().in("daywork_id", allCarries.isEmpty() ? Collections.singletonList(0L) : allCarries.stream().map(BizDayworkCarrier::getDayworkId).collect(Collectors.toList())).list();
        List<BizDaywork> bizDayworks = bizDayworkService.query().in("id", allCarries.isEmpty() ? Collections.singletonList(0L) : allCarries.stream().map(BizDayworkCarrier::getDayworkId).collect(Collectors.toList())).list();
        for (BizDaywork v : bizDayworks) {
            BizDayworkItem lastItem = bizDayworkItems.stream().filter(l -> l.getDayworkId().equals(v.getId())).findFirst().orElse(null);
            //不筛选status，当前批次最新一条报工
            BizDayworkItem lastItemAll = bizDayworkItemAll.stream().filter(l -> l.getDayworkId().equals(v.getId())).findFirst().orElse(null);
            //为了防止该工序已经周转到下一道序，且已经干了，所以判断如果当前processStepNumber和最新一条的步骤是否相同
            if (lastItemAll != null && (!lastItemAll.getProcessStepNumber().equals(bizDayworkItem.getProcessStepNumber()) || (lastItemAll.getStatus().equals("4") || lastItemAll.getStatus().equals("5") || lastItemAll.getStatus().equals("7")))) {
                return error(v.getLotCode() + "批次已周转，请勿重复操作");
            }
            if (lastItem != null && lastItem.getStatus().equals("3")) {
                List<BizDayworkItem> allItem = bizDayworkItemList.stream().filter(l -> l.getDayworkId().equals(v.getId()) && l.getTechnologicalProcessDetailId().equals(lastItem.getTechnologicalProcessDetailId())).collect(Collectors.toList());
                Integer lot = allItem.stream().mapToInt(BizDayworkItem::getQualifiedNum).sum();
                BizDayworkItem bizItem = new BizDayworkItem();
                bizItem.setDayworkId(lastItem.getDayworkId());
                bizItem.setProcessId(lastItem.getProcessId());
                bizItem.setTechnologicalProcessDetailId(lastItem.getTechnologicalProcessDetailId());
                bizItem.setStatus(bizDayworkItem.getStatus());
                bizItem.setFromDeptId(lastItem.getDeptId());
                bizItem.setFromDeptName(lastItem.getDeptName());
                if (bizDayworkItem.getStatus().equals("7") || bizDayworkItem.getStatus().equals("4")) {
                    v.setDeptId(bizDayworkItem.getDeptId());
                    v.setProcessQualifiedNum(v.getTemporaryProcessQualifiedNum());
                    bizDayworkService.updateById(v);
                }
                // 周转后如果是车间内的，状态为7，则需要从当前资源组中删除被邀请人
                if (bizDayworkItem.getStatus().equals("7") || bizDayworkItem.getStatus().equals("5")) {
                    v.setProtemProcessId(lastItem.getProcessId());
                    v.setProtemProcessStepNumber(lastItem.getProcessStepNumber());
                    // 如果被邀请人不是本工段内的人，则需要从当前资源组中删除被邀请人
                    bizProductionResourceGroupDetailService.deleTemporanyPeople(v);
                }
                if (v.getIsAmend() == 1) {
                    bizItem.setFormDayworkItemId(1L);
                }
                bizItem.setProdNum(v.getTemporaryProcessQualifiedNum());
                bizItem.setLotId(v.getLotId());
                bizItem.setLotCode(v.getLotCode());
                SysUser user = SecurityUtils.getLoginUser().getUser();
                bizItem.setUserId(user.getUserId());
                bizItem.setUserName(user.getUserName());
                bizItem.setNickName(user.getNickName());
                bizItem.setIsSpecial(lastItem.getIsSpecial());
                bizItem.setSpecialIsFirst(lastItem.getSpecialIsFirst());
                bizItem.setWorkingHours(0L);
                bizItem.setTenantId(lastItem.getTenantId());
                bizItem.setProductionPlanDetailId(lastItem.getProductionPlanDetailId());
                bizItem.setProductionPlanId(lastItem.getProductionPlanId());
                bizItem.setProductionPlanDetailSubDetailId(lastItem.getProductionPlanDetailSubDetailId());
                bizItem.setProductionPlanDetailSubDetailEquipmentId(lastItem.getProductionPlanDetailSubDetailEquipmentId());
                bizItem.setQualifiedNum(lot);
                bizItem.setTechnologicalProcessId(lastItem.getTechnologicalProcessId());
                bizItem.setProdNum(lot);
                bizItem.setEquipmentDetailId(lastItem.getEquipmentDetailId());
                bizItem.setEquipmentDetailCode(lastItem.getEquipmentDetailCode());
                bizItem.setDeptId(bizDayworkItem.getDeptId());
                bizItem.setDeptName(bizDayworkItem.getDeptName());
                bizItem.setStartTime(bizDayworkItem.getStartTime());
                bizItem.setTurnoverType(bizDayworkItem.getTurnoverType());
                bizItem.setTurnoverId(bizDayworkItem.getTurnoverId());
                bizItem.setTurnoverArea(bizDayworkItem.getTurnoverArea());
                bizItem.setPlaceId(bizDayworkItem.getPlaceId());
                bizItem.setPlace(bizDayworkItem.getPlace());
                bizItem.setProcessStepNumber(lastItem.getProcessStepNumber());
                batch = batch && bizDayworkItemService.saveOrUpdate(bizItem);

            }
        }
        return success();
    }

    @Log(title = "外协周转申请")
    @Transactional
    @PostMapping("/turnoverOutsourceAssist")
    public AjaxResult turnoverOutsourceAssist(@RequestBody BizDayworkItem bizDayworkItem) throws NoSuchFieldException, IllegalAccessException {
        setTenantId(bizDayworkItem);
        //判断当前是否在盘点
        BizTakeStockPeriod bizTakeStockPeriod = bizTakeStockPeriodService.query().eq("status", 1).one();
        if (bizTakeStockPeriod != null && bizTakeStockPeriod.getStatus() == 1) {
            return error("当前在盘点，禁止投产");
        }
        // 设置工时
        // 获取箱子关联的所有批次
        boolean batch = true;
        //切换数据源
        SysDept sysDept =new SysDept();
            sysDept = sysDeptMapper.selectDeptByCodeAndTenantId(bizDayworkItem.getDeptCode(), bizDayworkItem.getTenantId());
        bizDayworkItem.setDeptId(sysDept.getDeptId());
        bizDayworkItem.setDeptName(sysDept.getDeptName());
        List<BizDayworkCarrier> dayworkCarriers = bizDayworkCarrierService.query().eq("process_inspection_id", 0L).eq("is_changed", 0).eq("daywork_id", bizDayworkItem.getDayworkId()).list();
        List<BizDayworkCarrier> allCarries = bizDayworkCarrierService.query().eq("is_changed", 0).eq("process_inspection_id", 0L).in("carrier_id", dayworkCarriers.isEmpty() ? Collections.singletonList(0L) : dayworkCarriers.stream().map(BizDayworkCarrier::getCarrierId).collect(Collectors.toList())).list();
        // 关联批次的所有最后一条报工
        List<BizDayworkItem> bizDayworkItems = bizDayworkItemService.query().in("daywork_id", allCarries.isEmpty() ? Collections.singletonList(0L) : allCarries.stream().map(BizDayworkCarrier::getDayworkId).collect(Collectors.toList())).in("status", Arrays.asList("0", "1", "2", "3")).orderByDesc("status").orderByDesc("create_time").list();
        List<BizDayworkItem> bizDayworkItemAll = bizDayworkItemService.query().in("daywork_id", allCarries.isEmpty() ? Collections.singletonList(0L) : allCarries.stream().map(BizDayworkCarrier::getDayworkId).collect(Collectors.toList())).orderByDesc("create_time").list();
        List<BizDayworkItem> bizDayworkItemList = bizDayworkItemService.query().in("daywork_id", allCarries.isEmpty() ? Collections.singletonList(0L) : allCarries.stream().map(BizDayworkCarrier::getDayworkId).collect(Collectors.toList())).list();
        List<BizDaywork> bizDayworks = bizDayworkService.query().in("id", allCarries.isEmpty() ? Collections.singletonList(0L) : allCarries.stream().map(BizDayworkCarrier::getDayworkId).collect(Collectors.toList())).list();
        for (BizDaywork v : bizDayworks) {
            BizDayworkItem lastItem = bizDayworkItems.stream().filter(l -> l.getDayworkId().equals(v.getId())).findFirst().orElse(null);
            //不筛选status，当前批次最新一条报工
            BizDayworkItem lastItemAll = bizDayworkItemAll.stream().filter(l -> l.getDayworkId().equals(v.getId())).findFirst().orElse(null);
            //为了防止该工序已经周转到下一道序，且已经干了，所以判断如果当前processStepNumber和最新一条的步骤是否相同
            if (lastItemAll != null && (!lastItemAll.getProcessStepNumber().equals(bizDayworkItem.getProcessStepNumber()) || (lastItemAll.getStatus().equals("4") || lastItemAll.getStatus().equals("5") || lastItemAll.getStatus().equals("7")))) {
                return error(v.getLotCode() + "批次已周转，请勿重复操作");
            }
            if (lastItem != null && lastItem.getStatus().equals("3")) {
                List<BizDayworkItem> allItem = bizDayworkItemList.stream().filter(l -> l.getDayworkId().equals(v.getId()) && l.getTechnologicalProcessDetailId().equals(lastItem.getTechnologicalProcessDetailId())).collect(Collectors.toList());
                Integer lot = allItem.stream().mapToInt(BizDayworkItem::getQualifiedNum).sum();
                BizDayworkItem bizItem = new BizDayworkItem();
                bizItem.setDayworkId(lastItem.getDayworkId());
                bizItem.setProcessId(lastItem.getProcessId());
                bizItem.setTechnologicalProcessDetailId(lastItem.getTechnologicalProcessDetailId());
                bizItem.setStatus(bizDayworkItem.getStatus());
                bizItem.setFromDeptId(lastItem.getDeptId());
                bizItem.setFromDeptName(lastItem.getDeptName());
                if (bizDayworkItem.getStatus().equals("7") || bizDayworkItem.getStatus().equals("4")) {
                    v.setDeptId(bizDayworkItem.getDeptId());
                    v.setProcessQualifiedNum(v.getTemporaryProcessQualifiedNum());
                    bizDayworkService.updateById(v);
                }
                // 周转后如果是车间内的，状态为7，则需要从当前资源组中删除被邀请人
                if (bizDayworkItem.getStatus().equals("7") || bizDayworkItem.getStatus().equals("5")) {
                    v.setProtemProcessId(lastItem.getProcessId());
                    v.setProtemProcessStepNumber(lastItem.getProcessStepNumber());
                    // 如果被邀请人不是本工段内的人，则需要从当前资源组中删除被邀请人
                    bizProductionResourceGroupDetailService.deleTemporanyPeople(v);
                }
                if (v.getIsAmend() == 1) {
                    bizItem.setFormDayworkItemId(1L);
                }
                //当前工序第一条报工
                BizDayworkItem firstDayworkItem = bizDayworkItems.stream().filter(l -> l.getProcessStepNumber().equals(bizDayworkItem.getProcessStepNumber()) && l.getDayworkId().equals(v.getId())).sorted(Comparator.comparing(BizDayworkItem::getCreateTime)).findFirst().orElse(null);
                bizItem.setProdNum(v.getTemporaryProcessQualifiedNum());
                bizItem.setLotId(v.getLotId());
                bizItem.setLotCode(v.getLotCode());
                SysUser user = SecurityUtils.getLoginUser().getUser();
                bizItem.setUserId(firstDayworkItem.getUserId());
                bizItem.setUserName(firstDayworkItem.getUserName());
                bizItem.setNickName(firstDayworkItem.getNickName());
                //协作信息
                bizItem.setAssistNickName(user.getNickName());
                bizItem.setAssistUserId(user.getUserId());
                bizItem.setAssistUserName(user.getUserName());
                bizItem.setIsSpecial(lastItem.getIsSpecial());
                bizItem.setSpecialIsFirst(lastItem.getSpecialIsFirst());
                bizItem.setWorkingHours(0L);
                bizItem.setTenantId(lastItem.getTenantId());
                bizItem.setProductionPlanDetailId(lastItem.getProductionPlanDetailId());
                bizItem.setProductionPlanId(lastItem.getProductionPlanId());
                bizItem.setProductionPlanDetailSubDetailId(lastItem.getProductionPlanDetailSubDetailId());
                bizItem.setProductionPlanDetailSubDetailEquipmentId(lastItem.getProductionPlanDetailSubDetailEquipmentId());
                bizItem.setQualifiedNum(lot);
                bizItem.setTechnologicalProcessId(lastItem.getTechnologicalProcessId());
                bizItem.setProdNum(lot);
                bizItem.setEquipmentDetailId(lastItem.getEquipmentDetailId());
                bizItem.setEquipmentDetailCode(lastItem.getEquipmentDetailCode());
                bizItem.setDeptId(bizDayworkItem.getDeptId());
                bizItem.setDeptName(bizDayworkItem.getDeptName());
                bizItem.setStartTime(bizDayworkItem.getStartTime());
                bizItem.setTurnoverType(bizDayworkItem.getTurnoverType());
                bizItem.setTurnoverId(bizDayworkItem.getTurnoverId());
                bizItem.setTurnoverArea(bizDayworkItem.getTurnoverArea());
                bizItem.setPlaceId(bizDayworkItem.getPlaceId());
                bizItem.setPlace(bizDayworkItem.getPlace());
                bizItem.setProcessStepNumber(lastItem.getProcessStepNumber());
                batch = batch && bizDayworkItemService.saveOrUpdate(bizItem);

            }
        }
        return success();
    }

    // 周转申请都走这个方法，不再走原来的add方法
    @Log(title = "周转申请")
    @Transactional
    @PostMapping("/turnover")
    public AjaxResult turnover(@RequestBody BizDayworkItem bizDayworkItem) throws NoSuchFieldException, IllegalAccessException {
        setTenantId(bizDayworkItem);
        //判断当前是否在盘点
        BizTakeStockPeriod bizTakeStockPeriod = bizTakeStockPeriodService.query().eq("status", 1).one();
        if (bizTakeStockPeriod != null && bizTakeStockPeriod.getStatus() == 1) {
            return error("当前在盘点，禁止投产");
        }
        // 设置工时
        // 获取箱子关联的所有批次
        boolean batch = true;
//        bizDayworkItem.getCarrierId();
        // 根据 daywork_item 中的 daywork_id，获取到所有未解绑的【daywork 与 箱子】的集合，通过这个集合，可以知道该批次下绑定了多少个箱子
        List<BizDayworkCarrier> dayworkCarriers = bizDayworkCarrierService.query().eq("is_changed", 0).eq("process_inspection_id", 0L).eq("daywork_id", bizDayworkItem.getDayworkId()).list();
        // 再根据上面获得到的数据，通过箱子的id（carrier_id），再进行查找，有多少个批次与该箱子绑定，这是因为存在一箱多批的情况。这样就获得到了所有的批次
        List<BizDayworkCarrier> allCarries = bizDayworkCarrierService.query().eq("process_inspection_id", 0L).eq("is_changed", 0).in("carrier_id", dayworkCarriers.isEmpty() ? Collections.singletonList(0L) : dayworkCarriers.stream().map(BizDayworkCarrier::getCarrierId).collect(Collectors.toList())).list();

        // 根据获取到的所有批次的id，查询出所有批次的报工信息，并且状态是【"0", "1", "2", "3"】，按状态值倒序、创建日期的倒序，对数据进行排序，得到的数据是还未周转的数据。
        // 后续会通过该集合，获取某批次的最后一条报工信息
        List<BizDayworkItem> bizDayworkItems = bizDayworkItemService.query().in("daywork_id", allCarries.isEmpty() ? Collections.singletonList(0L) : allCarries.stream().map(BizDayworkCarrier::getDayworkId).collect(Collectors.toList())).in("status", Arrays.asList("0", "1", "2", "3")).orderByDesc("status").orderByDesc("create_time").list();
        List<BizDayworkItem> bizDayworkItemsAll = bizDayworkItemService.query().in("daywork_id", allCarries.isEmpty() ? Collections.singletonList(0L) : allCarries.stream().map(BizDayworkCarrier::getDayworkId).collect(Collectors.toList())).orderByDesc("create_time").list();
        // 根据获取到的所有批次的id，查询出所有批次的报工信息，不需要判断状态
        List<BizDayworkItem> bizDayworkItemList = bizDayworkItemService.query().in("daywork_id", allCarries.isEmpty() ? Collections.singletonList(0L) : allCarries.stream().map(BizDayworkCarrier::getDayworkId).collect(Collectors.toList())).list();
        // 获取所有的 daywork 数据集合
        List<BizDaywork> bizDayworks = bizDayworkService.query().in("id", allCarries.isEmpty() ? Collections.singletonList(0L) : allCarries.stream().map(BizDayworkCarrier::getDayworkId).collect(Collectors.toList())).list();
        //查询分选-包装的审核申请
        List<BizDayworkItemExamine> dayworkExamineList = bizDayworkItemExamineService.query().in("daywork_id", allCarries.isEmpty() ? Collections.singletonList(0L) : allCarries.stream().map(BizDayworkCarrier::getDayworkId).collect(Collectors.toList())).list();
        //需要新增的审核申请集合
        List<BizDayworkItemExamine> needAddList = new ArrayList<>();
        // 遍历 daywork 数据集合
        for (BizDaywork v : bizDayworks) {
            // 获取该批次的最后一条报工
            BizDayworkItem lastItem = bizDayworkItems.stream().filter(l -> l.getDayworkId().equals(v.getId())).findFirst().orElse(null);
            //批次所有报工，判断是否已经周转了，如果周转返回报错信息
            BizDayworkItem lastItemAll = bizDayworkItemsAll.stream().filter(l -> l.getDayworkId().equals(v.getId())).findFirst().orElse(null);
            //为了防止该工序已经周转到下一道序，且已经干了，所以判断如果当前processStepNumber和最新一条的步骤是否相同
            if (lastItemAll != null && (!lastItemAll.getProcessStepNumber().equals(bizDayworkItem.getProcessStepNumber()) || (lastItemAll.getStatus().equals("4") || lastItemAll.getStatus().equals("5") || lastItemAll.getStatus().equals("7")))) {
                return error(v.getLotCode() + "批次已周转，请勿重复操作");
            }
            // 如果最后一条报工信息存在，并且报工状态为：3，则说明该报工已经工序完成
            if (lastItem != null && lastItem.getStatus().equals("3")) {
                // 根据当前批次的id，获取该批次下的工序id与最后一条报工的工序id相同的所有报工信息
                // 因为同一工序可能存在多次报工，所以需要获取该批次下，该工序的所有报工信息，后续会进行合格数的统计
                List<BizDayworkItem> allItem = bizDayworkItemList.stream().filter(l -> l.getDayworkId().equals(v.getId()) && l.getTechnologicalProcessDetailId().equals(lastItem.getTechnologicalProcessDetailId())).collect(Collectors.toList());
                // 根据获得到的某工序的报工信息，进行合格数统计
                Integer lot = allItem.stream().mapToInt(BizDayworkItem::getQualifiedNum).sum();

                // 实例化一个报工信息对象，用于保存【周转】的报工记录
                BizDayworkItem bizItem = new BizDayworkItem();
                bizItem.setDayworkId(lastItem.getDayworkId());
                bizItem.setProcessId(lastItem.getProcessId());
                bizItem.setTechnologicalProcessDetailId(lastItem.getTechnologicalProcessDetailId());
                bizItem.setStatus(bizDayworkItem.getStatus());
                bizItem.setFromDeptId(lastItem.getDeptId());
                bizItem.setFromDeptName(lastItem.getDeptName());
                //添加分选-包装的审核申请
                if (bizDayworkItem.getIsNextPacking()) {
                    //如果有审核申请，则删除审核申请，重新新增
                    if (dayworkExamineList.size() > 0) {
                        //删除多余的审核申请
                        bizDayworkItemExamineService.removeBatchByIds(dayworkExamineList);
                    }
                    //新增审核申请
                    BizDayworkItemExamine examine = new BizDayworkItemExamine();
                    examine.setDayworkId(v.getId());
                    examine.setDayworkItemId(lastItem.getId());
                    examine.setDeptId(bizDayworkItem.getDeptId());
                    examine.setProductionPlanDetailId(bizDayworkItem.getProductionPlanDetailId());
                    examine.setProductDescription(bizDayworkItem.getProductDescription());
                    examine.setLotId(lastItem.getLotId());
                    examine.setLotCode(v.getLotCode());
                    examine.setProductId(v.getProductId());
                    examine.setTechnologicalProcessId(lastItem.getTechnologicalProcessId());
                    examine.setTechnologicalProcessDetailId(lastItem.getTechnologicalProcessDetailId());
                    examine.setProcessId(lastItem.getProcessId());
                    examine.setProcessAlias(bizDayworkItem.getProcess().getProcessAlias());
                    examine.setTenantId(bizDayworkItem.getTenantId());
                    examine.setStatus(0);
                    needAddList.add(examine);
                }
                // 如果报工状态为：7（已送达）或者4（待周转），则需要设置对应的daywork的当前部门id，以及合格数
                // 这里的状态值4/7，是由前端传递过来的。
                if (bizDayworkItem.getStatus().equals("7") || bizDayworkItem.getStatus().equals("4")) {
                    v.setDeptId(bizDayworkItem.getDeptId());
                    int sum = bizDayworkItems.stream()
                            .filter(l -> l.getProcessStepNumber().equals(bizDayworkItem.getProcessStepNumber()) && l.getDayworkId().equals(v.getId()))
                            .mapToInt(BizDayworkItem::getQualifiedNum) // 假设 getNum 返回一个 int 类型的值
                            .sum();
                    v.setTemporaryProcessQualifiedNum(sum);
                    bizDayworkService.updateById(v);
                }
                // 周转后如果是车间内的，状态为7，则需要从当前资源组中删除被邀请人
                if (bizDayworkItem.getStatus().equals("7") || bizDayworkItem.getStatus().equals("5")) {
                    v.setProtemProcessId(lastItem.getProcessId());
                    v.setProtemProcessStepNumber(lastItem.getProcessStepNumber());
                    // 如果被邀请人不是本工段内的人，则需要从当前资源组中删除被邀请人
                    bizProductionResourceGroupDetailService.deleTemporanyPeople(v);
                }
                // 如果是单批单改换，则设置form_daywork_item_id为1，表示没有原来的报工
                if (v.getIsAmend() == 1) {
                    bizItem.setFormDayworkItemId(1L);
                }
                bizItem.setLotId(v.getLotId());
                bizItem.setLotCode(v.getLotCode());
                SysUser user = SecurityUtils.getLoginUser().getUser();
                bizItem.setUserId(user.getUserId());
                bizItem.setUserName(user.getUserName());
                bizItem.setNickName(user.getNickName());
                bizItem.setIsSpecial(lastItem.getIsSpecial());
                bizItem.setSpecialIsFirst(lastItem.getSpecialIsFirst());
                bizItem.setWorkingHours(0L);
                bizItem.setDeptId(lastItem.getDeptId());
                bizItem.setTenantId(bizDayworkItem.getTenantId());
                bizItem.setProductionPlanDetailId(lastItem.getProductionPlanDetailId());
                bizItem.setProductionPlanId(lastItem.getProductionPlanId());
                bizItem.setProductionPlanDetailSubDetailId(lastItem.getProductionPlanDetailSubDetailId());
                bizItem.setProductionPlanDetailSubDetailEquipmentId(lastItem.getProductionPlanDetailSubDetailEquipmentId());
                bizItem.setQualifiedNum(lot);
                bizItem.setTechnologicalProcessId(lastItem.getTechnologicalProcessId());
                bizItem.setProdNum(lot);
                bizItem.setEquipmentDetailId(lastItem.getEquipmentDetailId());
                bizItem.setEquipmentDetailCode(lastItem.getEquipmentDetailCode());
                bizItem.setDeptId(bizDayworkItem.getDeptId());
                bizItem.setDeptName(bizDayworkItem.getDeptName());
                bizItem.setStartTime(bizDayworkItem.getStartTime());
                bizItem.setTurnoverId(bizDayworkItem.getTurnoverId());
                bizItem.setTurnoverType(bizDayworkItem.getTurnoverType());
                bizItem.setTurnoverArea(bizDayworkItem.getTurnoverArea());
                bizItem.setPlaceId(bizDayworkItem.getPlaceId());
                bizItem.setPlace(bizDayworkItem.getPlace());
                bizItem.setProcessStepNumber(lastItem.getProcessStepNumber());
                batch = batch && bizDayworkItemService.saveOrUpdate(bizItem);
                // 自动派活
                SysDept sysDept = sysDeptMapper.selectDeptById(bizDayworkItem.getDeptId());
                if (sysDept.getAutoAllocation() == 1) {
                    // 查资源组
                    List<BizProductionResourceGroup> productionResourceGroupList = bizProductionResourceGroupService.list(new QueryWrapper<BizProductionResourceGroup>().eq("dept_id", bizDayworkItem.getDeptId()).eq("is_deactivate", 0));

                    //查询是否已经分配资源组
                    BizProductionResourceGroupSubPlan groupSubPlan = new BizProductionResourceGroupSubPlan();
                    groupSubPlan.setDeptId(bizDayworkItem.getDeptId());
                    groupSubPlan.setProductionPlanDetailId(bizDayworkItem.getProductionPlanDetailId());

                    List<BizProductionResourceGroupSubPlan> groupSubPlanList = bizProductionResourceGroupSubPlanService.getAotList(groupSubPlan);
                    //如果没分配
                    if (groupSubPlanList.isEmpty()) {
                        //查产品id
                        BizProductionPlanDetail productionPlanDetail = bizProductionPlanDetailService.getOne(new QueryWrapper<BizProductionPlanDetail>().eq("id", bizDayworkItem.getProductionPlanDetailId()));
                        //存放保存的subPlanList
                        List<BizProductionResourceGroupSubPlan> subPlanList = new ArrayList<>();
                        for (BizProductionResourceGroup info : productionResourceGroupList) {
                            BizProductionResourceGroupSubPlan subPlan = new BizProductionResourceGroupSubPlan();
                            subPlan.setProductId(productionPlanDetail.getProductId());
                            subPlan.setProductionPlanDetailId(v.getProductionPlanDetailId());
                            subPlan.setTechnologicalProcessId(v.getTechnologicalProcessId());
                            subPlan.setResourceGroupId(info.getId());
                            subPlan.setDeptId(bizDayworkItem.getDeptId());
                            subPlan.setResourceGroupCode(info.getCode());
                            subPlanList.add(subPlan);
                        }
                        bizProductionResourceGroupSubPlanService.saveBatch(subPlanList);
                    }
                }
            }
        }

        bizDayworkItemExamineService.saveBatch(needAddList);
        return toAjax(batch);
    }

    @Log(title = "周转申请")
    @Transactional
    @PostMapping("/turnoverAssist")
    public AjaxResult turnoverAssist(@RequestBody BizDayworkItem bizDayworkItem) throws NoSuchFieldException, IllegalAccessException {
        //判断当前是否在盘点
        BizTakeStockPeriod bizTakeStockPeriod = bizTakeStockPeriodService.query().eq("status", 1).one();
        if (bizTakeStockPeriod != null && bizTakeStockPeriod.getStatus() == 1) {
            return error("当前在盘点，禁止投产");
        }
        // 设置工时
        // 获取箱子关联的所有批次
        boolean batch = true;
//        bizDayworkItem.getCarrierId();
        // 根据 daywork_item 中的 daywork_id，获取到所有未解绑的【daywork 与 箱子】的集合，通过这个集合，可以知道该批次下绑定了多少个箱子
        List<BizDayworkCarrier> dayworkCarriers = bizDayworkCarrierService.query().eq("is_changed", 0).eq("process_inspection_id", 0L).eq("daywork_id", bizDayworkItem.getDayworkId()).list();
        // 再根据上面获得到的数据，通过箱子的id（carrier_id），再进行查找，有多少个批次与该箱子绑定，这是因为存在一箱多批的情况。这样就获得到了所有的批次
        List<BizDayworkCarrier> allCarries = bizDayworkCarrierService.query().eq("process_inspection_id", 0L).eq("is_changed", 0).in("carrier_id", dayworkCarriers.isEmpty() ? Collections.singletonList(0L) : dayworkCarriers.stream().map(BizDayworkCarrier::getCarrierId).collect(Collectors.toList())).list();

        // 根据获取到的所有批次的id，查询出所有批次的报工信息，并且状态是【"0", "1", "2", "3"】，按状态值倒序、创建日期的倒序，对数据进行排序，得到的数据是还未周转的数据。
        // 后续会通过该集合，获取某批次的最后一条报工信息
        List<BizDayworkItem> bizDayworkItems = bizDayworkItemService.query().in("daywork_id", allCarries.isEmpty() ? Collections.singletonList(0L) : allCarries.stream().map(BizDayworkCarrier::getDayworkId).collect(Collectors.toList())).in("status", Arrays.asList("0", "1", "2", "3")).orderByDesc("status").orderByDesc("create_time").list();
        List<BizDayworkItem> bizDayworkItemsAll = bizDayworkItemService.query().in("daywork_id", allCarries.isEmpty() ? Collections.singletonList(0L) : allCarries.stream().map(BizDayworkCarrier::getDayworkId).collect(Collectors.toList())).orderByDesc("create_time").list();
        // 根据获取到的所有批次的id，查询出所有批次的报工信息，不需要判断状态
        List<BizDayworkItem> bizDayworkItemList = bizDayworkItemService.query().in("daywork_id", allCarries.isEmpty() ? Collections.singletonList(0L) : allCarries.stream().map(BizDayworkCarrier::getDayworkId).collect(Collectors.toList())).list();
        // 获取所有的 daywork 数据集合
        List<BizDaywork> bizDayworks = bizDayworkService.query().in("id", allCarries.isEmpty() ? Collections.singletonList(0L) : allCarries.stream().map(BizDayworkCarrier::getDayworkId).collect(Collectors.toList())).list();
        //查询分选-包装的审核申请
        List<BizDayworkItemExamine> dayworkExamineList = bizDayworkItemExamineService.query().in("daywork_id", allCarries.isEmpty() ? Collections.singletonList(0L) : allCarries.stream().map(BizDayworkCarrier::getDayworkId).collect(Collectors.toList())).list();
        //需要新增的审核申请集合
        List<BizDayworkItemExamine> needAddList = new ArrayList<>();
        // 遍历 daywork 数据集合
        for (BizDaywork v : bizDayworks) {
            // 获取该批次的最后一条报工
            BizDayworkItem lastItem = bizDayworkItems.stream().filter(l -> l.getDayworkId().equals(v.getId())).findFirst().orElse(null);
            //批次所有报工，判断是否已经周转了，如果周转返回报错信息
            BizDayworkItem lastItemAll = bizDayworkItemsAll.stream().filter(l -> l.getDayworkId().equals(v.getId())).findFirst().orElse(null);
            //为了防止该工序已经周转到下一道序，且已经干了，所以判断如果当前processStepNumber和最新一条的步骤是否相同
            if (lastItemAll != null && (!lastItemAll.getProcessStepNumber().equals(bizDayworkItem.getProcessStepNumber()) || (lastItemAll.getStatus().equals("4") || lastItemAll.getStatus().equals("5") || lastItemAll.getStatus().equals("7")))) {
                return error(v.getLotCode() + "批次已周转，请勿重复操作");
            }
            // 如果最后一条报工信息存在，并且报工状态为：3，则说明该报工已经工序完成
            if (lastItem != null && lastItem.getStatus().equals("3")) {
                // 根据当前批次的id，获取该批次下的工序id与最后一条报工的工序id相同的所有报工信息
                // 因为同一工序可能存在多次报工，所以需要获取该批次下，该工序的所有报工信息，后续会进行合格数的统计
                List<BizDayworkItem> allItem = bizDayworkItemList.stream().filter(l -> l.getDayworkId().equals(v.getId()) && l.getTechnologicalProcessDetailId().equals(lastItem.getTechnologicalProcessDetailId())).collect(Collectors.toList());
                // 根据获得到的某工序的报工信息，进行合格数统计
                Integer lot = allItem.stream().mapToInt(BizDayworkItem::getQualifiedNum).sum();

                // 实例化一个报工信息对象，用于保存【周转】的报工记录
                BizDayworkItem bizItem = new BizDayworkItem();
                bizItem.setDayworkId(lastItem.getDayworkId());
                bizItem.setProcessId(lastItem.getProcessId());
                bizItem.setTechnologicalProcessDetailId(lastItem.getTechnologicalProcessDetailId());
                bizItem.setStatus(bizDayworkItem.getStatus());
                bizItem.setFromDeptId(lastItem.getDeptId());
                bizItem.setFromDeptName(lastItem.getDeptName());
                //添加分选-包装的审核申请
                if (bizDayworkItem.getIsNextPacking()) {
                    //如果有审核申请，则删除审核申请，重新新增
                    if (dayworkExamineList.size() > 0) {
                        //删除多余的审核申请
                        bizDayworkItemExamineService.removeBatchByIds(dayworkExamineList);
                    }
                    //新增审核申请
                    BizDayworkItemExamine examine = new BizDayworkItemExamine();
                    examine.setDayworkId(v.getId());
                    examine.setDayworkItemId(lastItem.getId());
                    examine.setDeptId(bizDayworkItem.getDeptId());
                    examine.setProductionPlanDetailId(bizDayworkItem.getProductionPlanDetailId());
                    examine.setProductDescription(bizDayworkItem.getProductDescription());
                    examine.setLotId(lastItem.getLotId());
                    examine.setLotCode(v.getLotCode());
                    examine.setProductId(v.getProductId());
                    examine.setTechnologicalProcessId(lastItem.getTechnologicalProcessId());
                    examine.setTechnologicalProcessDetailId(lastItem.getTechnologicalProcessDetailId());
                    examine.setProcessId(lastItem.getProcessId());
                    if (bizDayworkItem.getProcess() == null) {
                        return error("报工数据异常，请联系管理员");
                    }
                    examine.setProcessAlias(bizDayworkItem.getProcess().getProcessAlias());
                    examine.setStatus(0);
                    needAddList.add(examine);
                }
                // 如果报工状态为：7（已送达）或者4（待周转），则需要设置对应的daywork的当前部门id，以及合格数
                // 这里的状态值4/7，是由前端传递过来的。
                if (bizDayworkItem.getStatus().equals("7") || bizDayworkItem.getStatus().equals("4")) {
                    v.setDeptId(bizDayworkItem.getDeptId());
                    int sum = bizDayworkItems.stream()
                            .filter(l -> l.getProcessStepNumber().equals(bizDayworkItem.getProcessStepNumber()))
                            .mapToInt(BizDayworkItem::getQualifiedNum) // 假设 getNum 返回一个 int 类型的值
                            .sum();
                    v.setTemporaryProcessQualifiedNum(sum);
                    bizDayworkService.updateById(v);
                }
                // 周转后如果是车间内的，状态为7，则需要从当前资源组中删除被邀请人
                if (bizDayworkItem.getStatus().equals("7") || bizDayworkItem.getStatus().equals("5")) {
                    v.setProtemProcessId(lastItem.getProcessId());
                    v.setProtemProcessStepNumber(lastItem.getProcessStepNumber());
                    // 如果被邀请人不是本工段内的人，则需要从当前资源组中删除被邀请人
                    bizProductionResourceGroupDetailService.deleTemporanyPeople(v);
                }
                // 如果是单批单改换，则设置form_daywork_item_id为1，表示没有原来的报工
                if (v.getIsAmend() == 1) {
                    bizItem.setFormDayworkItemId(1L);
                }
                //当前工序第一条报工
                BizDayworkItem firstDayworkItem = bizDayworkItems.stream().filter(l -> l.getProcessStepNumber().equals(bizDayworkItem.getProcessStepNumber()) && l.getDayworkId().equals(v.getId())).sorted(Comparator.comparing(BizDayworkItem::getCreateTime)).findFirst().orElse(null);
                bizItem.setLotId(v.getLotId());
                bizItem.setLotCode(v.getLotCode());
                SysUser user = SecurityUtils.getLoginUser().getUser();
                bizItem.setUserId(firstDayworkItem.getUserId());
                bizItem.setUserName(firstDayworkItem.getUserName());
                bizItem.setNickName(firstDayworkItem.getNickName());
                //协作信息
                bizItem.setAssistNickName(user.getNickName());
                bizItem.setAssistUserId(user.getUserId());
                bizItem.setAssistUserName(user.getUserName());
                bizItem.setIsSpecial(lastItem.getIsSpecial());
                bizItem.setSpecialIsFirst(lastItem.getSpecialIsFirst());
                bizItem.setWorkingHours(0L);
                bizItem.setDeptId(lastItem.getDeptId());
                bizItem.setTenantId(lastItem.getTenantId());
                bizItem.setProductionPlanDetailId(lastItem.getProductionPlanDetailId());
                bizItem.setProductionPlanId(lastItem.getProductionPlanId());
                bizItem.setProductionPlanDetailSubDetailId(lastItem.getProductionPlanDetailSubDetailId());
                bizItem.setProductionPlanDetailSubDetailEquipmentId(lastItem.getProductionPlanDetailSubDetailEquipmentId());
                bizItem.setQualifiedNum(lot);
                bizItem.setTechnologicalProcessId(lastItem.getTechnologicalProcessId());
                bizItem.setProdNum(lot);
                bizItem.setEquipmentDetailId(lastItem.getEquipmentDetailId());
                bizItem.setEquipmentDetailCode(lastItem.getEquipmentDetailCode());
                bizItem.setDeptId(bizDayworkItem.getDeptId());
                bizItem.setDeptName(bizDayworkItem.getDeptName());
                bizItem.setStartTime(bizDayworkItem.getStartTime());
                bizItem.setTurnoverId(bizDayworkItem.getTurnoverId());
                bizItem.setTurnoverType(bizDayworkItem.getTurnoverType());
                bizItem.setTurnoverArea(bizDayworkItem.getTurnoverArea());
                bizItem.setTenantId(bizDayworkItem.getTenantId());
                bizItem.setPlaceId(bizDayworkItem.getPlaceId());
                bizItem.setPlace(bizDayworkItem.getPlace());
                bizItem.setProcessStepNumber(lastItem.getProcessStepNumber());
                batch = batch && bizDayworkItemService.saveOrUpdate(bizItem);
                // 自动派活
                SysDept sysDept = sysDeptMapper.selectDeptById(bizDayworkItem.getDeptId());
                if (sysDept.getAutoAllocation() == 1) {
                    // 查资源组
                    List<BizProductionResourceGroup> productionResourceGroupList = bizProductionResourceGroupService.list(new QueryWrapper<BizProductionResourceGroup>().eq("dept_id", bizDayworkItem.getDeptId()).eq("is_deactivate", 0));

                    //查询是否已经分配资源组
                    BizProductionResourceGroupSubPlan groupSubPlan = new BizProductionResourceGroupSubPlan();
                    groupSubPlan.setDeptId(bizDayworkItem.getDeptId());
                    groupSubPlan.setProductionPlanDetailId(bizDayworkItem.getProductionPlanDetailId());

                    List<BizProductionResourceGroupSubPlan> groupSubPlanList = bizProductionResourceGroupSubPlanService.getAotList(groupSubPlan);
                    //如果没分配
                    if (groupSubPlanList.isEmpty()) {
                        //查产品id
                        BizProductionPlanDetail productionPlanDetail = bizProductionPlanDetailService.getOne(new QueryWrapper<BizProductionPlanDetail>().eq("id", bizDayworkItem.getProductionPlanDetailId()));
                        //存放保存的subPlanList
                        List<BizProductionResourceGroupSubPlan> subPlanList = new ArrayList<>();
                        for (BizProductionResourceGroup info : productionResourceGroupList) {
                            BizProductionResourceGroupSubPlan subPlan = new BizProductionResourceGroupSubPlan();
                            subPlan.setProductId(productionPlanDetail.getProductId());
                            subPlan.setProductionPlanDetailId(v.getProductionPlanDetailId());
                            subPlan.setTechnologicalProcessId(v.getTechnologicalProcessId());
                            subPlan.setResourceGroupId(info.getId());
                            subPlan.setDeptId(bizDayworkItem.getDeptId());
                            subPlan.setResourceGroupCode(info.getCode());
                            subPlanList.add(subPlan);
                        }
                        bizProductionResourceGroupSubPlanService.saveBatch(subPlanList);
                    }
                }
            }
        }

        bizDayworkItemExamineService.saveBatch(needAddList);
        return toAjax(batch);
    }

    @Log(title = "内部外协周转申请")
    @Transactional
    @PostMapping("/turnoverInner")
    public AjaxResult turnoverInner(@RequestBody BizDayworkItem bizDayworkItem) throws NoSuchFieldException, IllegalAccessException {
        //判断当前是否在盘点
        BizTakeStockPeriod bizTakeStockPeriod = bizTakeStockPeriodService.query().eq("status", 1).one();
        if (bizTakeStockPeriod != null && bizTakeStockPeriod.getStatus() == 1) {
            return error("当前在盘点，禁止投产");
        }
        // 设置工时
        // 获取箱子关联的所有批次
        boolean batch = true;
//        bizDayworkItem.getCarrierId();
        // 根据 daywork_item 中的 daywork_id，获取到所有未解绑的【daywork 与 箱子】的集合，通过这个集合，可以知道该批次下绑定了多少个箱子
        List<BizDayworkCarrier> dayworkCarriers = bizDayworkCarrierService.query().eq("is_changed", 0).eq("process_inspection_id", 0L).eq("daywork_id", bizDayworkItem.getDayworkId()).list();
        // 再根据上面获得到的数据，通过箱子的id（carrier_id），再进行查找，有多少个批次与该箱子绑定，这是因为存在一箱多批的情况。这样就获得到了所有的批次
        List<BizDayworkCarrier> allCarries = bizDayworkCarrierService.query().eq("process_inspection_id", 0L).eq("is_changed", 0).in("carrier_id", dayworkCarriers.isEmpty() ? Collections.singletonList(0L) : dayworkCarriers.stream().map(BizDayworkCarrier::getCarrierId).collect(Collectors.toList())).list();

        // 根据获取到的所有批次的id，查询出所有批次的报工信息，并且状态是【"0", "1", "2", "3"】，按状态值倒序、创建日期的倒序，对数据进行排序，得到的数据是还未周转的数据。
        // 后续会通过该集合，获取某批次的最后一条报工信息
        List<BizDayworkItem> bizDayworkItems = bizDayworkItemService.query().in("daywork_id", allCarries.isEmpty() ? Collections.singletonList(0L) : allCarries.stream().map(BizDayworkCarrier::getDayworkId).collect(Collectors.toList())).in("status", Arrays.asList("0", "1", "2", "3")).orderByDesc("status").orderByDesc("create_time").list();
        List<BizDayworkItem> bizDayworkItemsAll = bizDayworkItemService.query().in("daywork_id", allCarries.isEmpty() ? Collections.singletonList(0L) : allCarries.stream().map(BizDayworkCarrier::getDayworkId).collect(Collectors.toList())).orderByDesc("create_time").list();
        // 根据获取到的所有批次的id，查询出所有批次的报工信息，不需要判断状态
        List<BizDayworkItem> bizDayworkItemList = bizDayworkItemService.query().in("daywork_id", allCarries.isEmpty() ? Collections.singletonList(0L) : allCarries.stream().map(BizDayworkCarrier::getDayworkId).collect(Collectors.toList())).list();
        // 获取所有的 daywork 数据集合
        List<BizDaywork> bizDayworks = bizDayworkService.query().in("id", allCarries.isEmpty() ? Collections.singletonList(0L) : allCarries.stream().map(BizDayworkCarrier::getDayworkId).collect(Collectors.toList())).list();
        //获取周转工段的周转区
        List<BizTurnover> turnoverList = bizTurnoverService.query().eq("dept_id", bizDayworkItem.getDeptId()).eq("status", 9).list();
        // 遍历 daywork 数据集合
        for (BizDaywork v : bizDayworks) {
            // 获取该批次的最后一条报工
            BizDayworkItem lastItem = bizDayworkItems.stream().filter(l -> l.getDayworkId().equals(v.getId())).findFirst().orElse(null);
            //批次所有报工，判断是否已经周转了，如果周转返回报错信息
            BizDayworkItem lastItemAll = bizDayworkItemsAll.stream().filter(l -> l.getDayworkId().equals(v.getId())).findFirst().orElse(null);
            //为了防止该工序已经周转到下一道序，且已经干了，所以判断如果当前processStepNumber和最新一条的步骤是否相同
            if (lastItemAll != null && (!lastItemAll.getProcessStepNumber().equals(bizDayworkItem.getProcessStepNumber()) || (lastItemAll.getStatus().equals("4") || lastItemAll.getStatus().equals("5") || lastItemAll.getStatus().equals("7")))) {
                return error(v.getLotCode() + "批次已周转，请勿重复操作");
            }
            // 如果最后一条报工信息存在，并且报工状态为：3，则说明该报工已经工序完成
            if (lastItem != null && lastItem.getStatus().equals("3")) {
                // 根据当前批次的id，获取该批次下的工序id与最后一条报工的工序id相同的所有报工信息
                // 因为同一工序可能存在多次报工，所以需要获取该批次下，该工序的所有报工信息，后续会进行合格数的统计
                List<BizDayworkItem> allItem = bizDayworkItemList.stream().filter(l -> l.getDayworkId().equals(v.getId()) && l.getTechnologicalProcessDetailId().equals(lastItem.getTechnologicalProcessDetailId())).collect(Collectors.toList());
                // 根据获得到的某工序的报工信息，进行合格数统计
                Integer lot = allItem.stream().mapToInt(BizDayworkItem::getQualifiedNum).sum();

                // 实例化一个报工信息对象，用于保存【周转】的报工记录
                BizDayworkItem bizItem = new BizDayworkItem();
                bizItem.setDayworkId(lastItem.getDayworkId());
                bizItem.setProcessId(lastItem.getProcessId());
                bizItem.setTechnologicalProcessDetailId(lastItem.getTechnologicalProcessDetailId());
                bizItem.setStatus(bizDayworkItem.getStatus());
                bizItem.setFromDeptId(lastItem.getDeptId());
                bizItem.setFromDeptName(lastItem.getDeptName());
                bizItem.setOutsourceDetailId(lastItem.getOutsourceDetailId());
                // 如果报工状态为：7（已送达）或者4（待周转），则需要设置对应的daywork的当前部门id，以及合格数
                // 这里的状态值4/7，是由前端传递过来的。
                if (bizDayworkItem.getStatus().equals("7") || bizDayworkItem.getStatus().equals("4")) {
                    v.setDeptId(bizDayworkItem.getDeptId());
                    int sum = bizDayworkItems.stream()
                            .filter(l -> l.getProcessStepNumber().equals(bizDayworkItem.getProcessStepNumber()) && l.getDayworkId().equals(v.getId()))
                            .mapToInt(BizDayworkItem::getQualifiedNum) // 假设 getNum 返回一个 int 类型的值
                            .sum();
                    v.setTemporaryProcessQualifiedNum(sum);
                    bizDayworkService.updateById(v);
                }
                // 周转后如果是车间内的，状态为7，则需要从当前资源组中删除被邀请人
                if (bizDayworkItem.getStatus().equals("7") || bizDayworkItem.getStatus().equals("5")) {
                    v.setProtemProcessId(lastItem.getProcessId());
                    v.setProtemProcessStepNumber(lastItem.getProcessStepNumber());
                    // 如果被邀请人不是本工段内的人，则需要从当前资源组中删除被邀请人
                    bizProductionResourceGroupDetailService.deleTemporanyPeople(v);
                }
                // 如果是单批单改换，则设置form_daywork_item_id为1，表示没有原来的报工
                if (v.getIsAmend() == 1) {
                    bizItem.setFormDayworkItemId(1L);
                }
                bizItem.setLotId(v.getLotId());
                bizItem.setLotCode(v.getLotCode());
                SysUser user = SecurityUtils.getLoginUser().getUser();
                bizItem.setUserId(user.getUserId());
                bizItem.setUserName(user.getUserName());
                bizItem.setNickName(user.getNickName());
                bizItem.setIsSpecial(lastItem.getIsSpecial());
                bizItem.setSpecialIsFirst(lastItem.getSpecialIsFirst());
                bizItem.setWorkingHours(0L);
                bizItem.setDeptId(lastItem.getDeptId());
                bizItem.setTenantId(lastItem.getTenantId());
                bizItem.setProductionPlanDetailId(lastItem.getProductionPlanDetailId());
                bizItem.setProductionPlanId(lastItem.getProductionPlanId());
                bizItem.setProductionPlanDetailSubDetailId(lastItem.getProductionPlanDetailSubDetailId());
                bizItem.setProductionPlanDetailSubDetailEquipmentId(lastItem.getProductionPlanDetailSubDetailEquipmentId());
                bizItem.setQualifiedNum(lot);
                bizItem.setTechnologicalProcessId(lastItem.getTechnologicalProcessId());
                bizItem.setProdNum(lot);
                bizItem.setEquipmentDetailId(lastItem.getEquipmentDetailId());
                bizItem.setEquipmentDetailCode(lastItem.getEquipmentDetailCode());
                bizItem.setIsSort(lastItem.getIsSort());
                bizItem.setDeptId(bizDayworkItem.getDeptId());
                bizItem.setDeptName(bizDayworkItem.getDeptName());
                bizItem.setStartTime(bizDayworkItem.getStartTime());
                bizItem.setTurnoverId(bizDayworkItem.getTurnoverId());
                bizItem.setTurnoverType(bizDayworkItem.getTurnoverType());
                bizItem.setTurnoverArea(bizDayworkItem.getTurnoverArea());
                bizItem.setTenantId(bizDayworkItem.getTenantId());
                if (bizDayworkItem.getPlaceId() == null) {
                    bizItem.setPlaceId(turnoverList.stream().map(BizTurnover::getId).map(String::valueOf).collect(Collectors.joining("、")));
                    bizItem.setPlace(turnoverList.stream().map(BizTurnover::getCode).collect(Collectors.joining("、")));
                } else {
                    bizItem.setPlaceId(bizDayworkItem.getPlaceId());
                    bizItem.setPlace(bizDayworkItem.getPlace());
                }

                bizItem.setProcessStepNumber(lastItem.getProcessStepNumber());
                bizItem.setOutsourceDetailId(lastItem.getOutsourceDetailId());
                bizItem.setIsWx(1);
                batch = batch && bizDayworkItemService.saveOrUpdate(bizItem);
                // 自动派活
                SysDept sysDept = sysDeptMapper.selectDeptById(bizDayworkItem.getDeptId());
                if (sysDept.getAutoAllocation() == 1) {
                    // 查资源组
                    List<BizProductionResourceGroup> productionResourceGroupList = bizProductionResourceGroupService.list(new QueryWrapper<BizProductionResourceGroup>().eq("dept_id", bizDayworkItem.getDeptId()).eq("is_deactivate", 0));

                    //查询是否已经分配资源组
                    BizProductionResourceGroupSubPlan groupSubPlan = new BizProductionResourceGroupSubPlan();
                    groupSubPlan.setDeptId(bizDayworkItem.getDeptId());
                    groupSubPlan.setProductionPlanDetailId(bizDayworkItem.getProductionPlanDetailId());

                    List<BizProductionResourceGroupSubPlan> groupSubPlanList = bizProductionResourceGroupSubPlanService.getAotList(groupSubPlan);
                    //如果没分配
                    if (groupSubPlanList.isEmpty()) {
                        //查产品id
                        BizProductionPlanDetail productionPlanDetail = bizProductionPlanDetailService.getOne(new QueryWrapper<BizProductionPlanDetail>().eq("id", bizDayworkItem.getProductionPlanDetailId()));
                        //存放保存的subPlanList
                        List<BizProductionResourceGroupSubPlan> subPlanList = new ArrayList<>();
                        for (BizProductionResourceGroup info : productionResourceGroupList) {
                            BizProductionResourceGroupSubPlan subPlan = new BizProductionResourceGroupSubPlan();
                            subPlan.setProductId(productionPlanDetail.getProductId());
                            subPlan.setProductionPlanDetailId(v.getProductionPlanDetailId());
                            subPlan.setTechnologicalProcessId(v.getTechnologicalProcessId());
                            subPlan.setResourceGroupId(info.getId());
                            subPlan.setDeptId(bizDayworkItem.getDeptId());
                            subPlan.setResourceGroupCode(info.getCode());
                            subPlanList.add(subPlan);
                        }
                        bizProductionResourceGroupSubPlanService.saveBatch(subPlanList);
                    }
                }
            }
        }
        return toAjax(batch);
    }

}
