package cn.ezhizao.project.business.product.domain;

import cn.ezhizao.framework.aspectj.lang.annotation.Excel;
import cn.ezhizao.framework.web.domain.BaseEntity;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableName;

import lombok.Data;
import io.swagger.annotations.ApiModelProperty;

import java.util.List;


/**
 * 报工载具中间表对象 biz_daywork_carrier
 *
 * @author ezhizao
 * @date 2023-12-04
 */
@Data
@TableName(value = "biz_daywork_carrier")
public class BizDayworkCarrier extends BaseEntity
{
    private static final long serialVersionUID = 1L;

    /** 租户（厂别）id */
    @ApiModelProperty(value = "${comment}")
    private Long tenantId;

    /** daywork id */
    @ApiModelProperty(value = "${comment}")
    private Long dayworkId;

    /** 计划单id */
    @ApiModelProperty(value = "${comment}")
    private Long productionPlanId;

    /** 子计划id */
    @ApiModelProperty(value = "${comment}")
    private Long productionPlanDetailSubDetailId;

    /** 计划单明细id */
    @ApiModelProperty(value = "${comment}")
    private Long productionPlanDetailId;

    /** 子计划工序对应的设备id */
    @ApiModelProperty(value = "${comment}")
    private Long productionPlanDetailSubDetailEquipmentId;

    /** 批次号 */
    @ApiModelProperty(value = "${comment}")
    private Long lotId;

    @TableField(exist = false)
    private String lotCode;

    /** 产品id */
    @ApiModelProperty(value = "${comment}")
    private Long productId;

    /** 工艺id（通过工艺id，获取版本号） */
    @ApiModelProperty(value = "${comment}")
    private Long technologicalProcessId;

    /** 用户id */
    @ApiModelProperty(value = "${comment}")
    private Long userId;

    /** 箱子id */
    @ApiModelProperty(value = "${comment}")
    private Long carrierId;

    /** 箱子编码 */
    @Excel(name = "箱子编码")
    @ApiModelProperty(value = "箱子编码")
    private String carrierCode;

    /** 是否被更换 */
    @Excel(name = "是否被更换")
    @ApiModelProperty(value = "是否被更换")
    private Integer isChanged;

    @ApiModelProperty("序检外键")
    private Long processInspectionId;

    //工序编码
    @TableField(exist = false)
    private List<String> processCode;
    @TableField(exist = false)
    private Long value;
    @TableField(exist = false)
    private String label;
    @TableField(exist = false)
    private Long deptId;

}
