package cn.ezhizao.project.business.product.domain;

import cn.ezhizao.framework.aspectj.lang.annotation.Excel;
import cn.ezhizao.framework.web.domain.BaseEntity;
import com.baomidou.mybatisplus.annotation.*;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Data;
import io.swagger.annotations.ApiModelProperty;

import java.util.Date;

/**
 * 报工记录协作者对象 biz_daywork_item_collaboration
 *
 * @author ezhizao
 * @date 2024-01-18
 */
@Data
@TableName(value = "biz_daywork_item_collaboration")
public class BizDayworkItemCollaboration extends Model<BizDayworkItemCollaboration> {
    private static final long serialVersionUID = 1L;

    /**
     * itemID
     */
    @ApiModelProperty(value = "${comment}")
    private Long dayworkItemId;

    /**
     * itemID
     */
    @ApiModelProperty(value = "${comment}")
    private Long dayworkId;

    /**
     * 用户id
     */
    @ApiModelProperty(value = "${comment}")
    private Long userId;

    /**
     * 员工编码
     */
    @Excel(name = "员工编码")
    @ApiModelProperty(value = "员工编码")
    private String userName;

    /**
     * 员工姓名
     */
    @Excel(name = "员工姓名")
    @ApiModelProperty(value = "员工姓名")
    private String nickName;


    /**
     * 创建时间
     */
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date createTime;


    /**
     * 更新者 id
     */

    @TableField(value = "updater_id", fill = FieldFill.UPDATE)
    private Long updaterId;

    /**
     * 创建者 id
     */
    @TableField(value = "creator_id", fill = FieldFill.INSERT)
    private Long creatorId;

    /**
     * 软删除标记
     */
    @TableLogic
    private Integer deleted;

    /**
     * 乐观锁标记
     */
    @Version
    private Long version;


    /**
     * 更新时间
     */
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @TableField(value = "update_time", fill = FieldFill.UPDATE)
    private Date updateTime;

    /**
     * 备注
     */
    @Excel(name = "备注")
    private String remark;

}
