package cn.ezhizao.project.business.product.domain;

import cn.ezhizao.framework.aspectj.lang.annotation.Excel;
import cn.ezhizao.framework.web.domain.BaseEntity;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableName;
import lombok.Data;
import io.swagger.annotations.ApiModelProperty;

/**
 * 序检明细对象 biz_process_inspection_detail
 *
 * @author ezhizao
 * @date 2024-06-20
 */
@Data
@TableName(value = "biz_process_inspection_detail")
public class BizProcessInspectionDetail extends BaseEntity
{
    private static final long serialVersionUID = 1L;

    /** 租户（厂别）id */
    @ApiModelProperty(value = "${comment}")
    private Long tenantId;

    /** 序检主表的id */
    @ApiModelProperty(value = "${comment}")
    private Long processInspectionId;

    /** 用户id */
    @ApiModelProperty(value = "${comment}")
    private Long userId;

    /** 员工昵称
 */
    @Excel(name = "员工昵称")
    @ApiModelProperty(value = "员工昵称")
    private String nickName;

    /** daywork的id */
    @ApiModelProperty(value = "员工昵称")
    private Long dayworkId;

    /** daywork_item的id */
    @ApiModelProperty(value = "员工昵称")
    private Long dayworkItemId;

    /** 计划单id */
    @ApiModelProperty(value = "员工昵称")
    private Long productionPlanId;

    /** 计划单明细 */
    @ApiModelProperty(value = "员工昵称")
    private Long productionPlanDetailId;

    /** 子计划id */
    @ApiModelProperty(value = "员工昵称")
    private Long productionPlanDetailSubDetailId;

    /** 批次id */
    @ApiModelProperty(value = "批次id")
    private Long lotId;

    /** 批次号 */
    @Excel(name = "批次号")
    @ApiModelProperty(value = "批次号")
    private String lotCode;

    /** 产品描述 */
    @Excel(name = "产品描述")
    @ApiModelProperty(value = "产品描述")
    private String productDescription;

    /** 检查标准外键id */
    @ApiModelProperty(value = "产品描述")
    private Long inspectionInstructionId;

    /** 检查指导书2,分选标准1 */
    @Excel(name = "检查指导书2,分选标准1")
    @ApiModelProperty(value = "检查指导书2,分选标准1")
    private Integer type;

    /** 检查指导书内容/分选标准内容 */
    @Excel(name = "检查指导书内容/分选标准内容")
    @ApiModelProperty(value = "检查指导书内容/分选标准内容")
    private String checkStandard;

    @ApiModelProperty("检查结果")
    @Excel(name = "检查结果")
    private String checkResult;

    /** 超差范围 */
    @Excel(name = "超差范围")
    @ApiModelProperty(value = "超差范围")
    private String exceedLimits;

    /** 工段id（当前工段的id） */
    @ApiModelProperty(value = "超差范围")
    private Long deptId;

    /** 产品id */
    @ApiModelProperty(value = "超差范围")
    private Long productId;

    /** 废品量 */
    @Excel(name = "废品量")
    @ApiModelProperty(value = "废品量")
    private Long rejectNum;

    /** 不合格量 */
    @Excel(name = "不合格量")
    @ApiModelProperty(value = "不合格量")
    private Long disqualificationNum;

    /** 检测量 */
    @Excel(name = "检测量")
    @ApiModelProperty(value = "检测量")
    private Long examiningNum;
    @TableField(exist = false)
    private String processAlias;
    @TableField(exist = false)
    private String remark;
    @TableField(exist = false)
    private Integer status;
    @TableField(exist = false)
    private String inspectionName;
    private Long inspectionStandardsId;
    @TableField(exist = false)
    private String inspectionType;

}
