package cn.ezhizao.project.business.product.domain;

import cn.ezhizao.framework.aspectj.lang.annotation.Excel;
import cn.ezhizao.framework.web.domain.BaseEntity;
import com.baomidou.mybatisplus.annotation.TableName;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

/**
 * 子计划对应的工序指定的使用设备对象 biz_production_plan_detail_sub_detail_equipment_user
 *
 * @author ezhizao
 * @date 2023-11-20
 */
@Data
@TableName(value = "biz_production_plan_detail_sub_detail_equipment_user")
public class BizProductionPlanDetailSubDetailEquipmentUser extends BaseEntity
{
    private static final long serialVersionUID = 1L;

    /** 租户（厂别）id */
    @ApiModelProperty(value = "${comment}")
    private Long tenantId;

    /** 子计划工序对应的设备id */
    @ApiModelProperty(value = "${comment}")
    private Long productionPlanDetailSubDetailEquipmentId;

    /** 设备id */
    @ApiModelProperty(value = "${comment}")
    private Long equipmentDetailId;

    /** 设备编码 */
    @Excel(name = "设备编码")
    @ApiModelProperty(value = "设备编码")
    private String equipmentDetailCode;

    /** 用户id */
    @ApiModelProperty(value = "设备编码")
    private Long userId;

    /** 员工编码 */
    @Excel(name = "员工编码")
    @ApiModelProperty(value = "员工编码")
    private String userName;

    /** 员工姓名 */
    @Excel(name = "员工姓名")
    @ApiModelProperty(value = "员工姓名")
    private String nickName;

}
