package cn.ezhizao.project.business.product.mapper;

import java.util.List;

import cn.ezhizao.project.business.product.domain.BizCarrierCategory;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import cn.ezhizao.project.business.product.domain.BizCarrier;

/**
 * 载具详情Mapper接口
 *
 * @author ezhizao
 * @date 2023-12-04
 */
public interface BizCarrierMapper extends BaseMapper<BizCarrier>
{
    /**
     * 查询载具详情列表
     *
     * @param bizCarrier 载具详情
     * @return 载具详情集合
     */
    public List<BizCarrier> getList(BizCarrier bizCarrier);

    /**
     * 物理删除
     * @param bizCarrier
     * @return 删除结果
    */
    public int physicalDelete(BizCarrier bizCarrier);

    BizCarrierCategory getCarrierCategory(Long id);

    BizCarrier checkIspection(String carrierCode);
}
