package cn.ezhizao.project.business.product.mapper;

import java.util.List;

import cn.ezhizao.project.business.product.domain.BizLot;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;


/**
 * 批次号Mapper接口
 *
 * @author ezhizao
 * @date 2023-12-04
 */
public interface BizLotMapper extends BaseMapper<BizLot>
{
    /**
     * 查询批次号列表（正常批次）
     *
     * @param bizLot 批次号
     * @return 批次号集合
     */
    public List<BizLot> getList(BizLot bizLot);


    /**
     * 查询所有批次
     *
     * @param bizLot 批次号
     * @return 批次号集合
     */
    public List<BizLot> getAllList(BizLot bizLot);

    public List<BizLot> getWasteRecyclingLot(BizLot bizLot);

    /**
     * 物理删除
     * @param bizLot
     * @return 删除结果
    */
    public int physicalDelete(BizLot bizLot);

    List<BizLot> getCheckLotList(BizLot bizLot);
}
