package cn.ezhizao.project.business.product.mapper;

import cn.ezhizao.project.business.product.domain.BizDaywork;
import cn.ezhizao.project.business.product.domain.BizReturnReceiptDetail;
import cn.ezhizao.project.system.domain.SysDept;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;

import java.util.List;


/**
 * 外协单从Mapper接口
 *
 * @author ezhizao
 * @date 2024-05-08
 */
public interface BizReturnReceiptDetailMapper extends BaseMapper<BizReturnReceiptDetail>
{
    /**
     * 查询外协单从列表
     *
     * @param bizReturnReceiptDetail 外协单从
     * @return 外协单从集合
     */
    public List<BizReturnReceiptDetail> getList(BizReturnReceiptDetail bizReturnReceiptDetail);
    public List<BizReturnReceiptDetail> getFinishedReturnList(BizReturnReceiptDetail bizReturnReceiptDetail);

    /**
     * 物理删除
     * @param bizReturnReceiptDetail
     * @return 删除结果
    */
    public int physicalDelete(BizReturnReceiptDetail bizReturnReceiptDetail);
    public List<SysDept> getTurnoverAbDeptList(BizDaywork bizDaywork);
    public List<SysDept> getTurnoverDeptList(BizDaywork bizDaywork);
}
