package cn.ezhizao.project.business.product.service;

import cn.ezhizao.project.business.product.domain.BizLotTechnologicalProcess;
import com.baomidou.mybatisplus.extension.service.IService;

import java.util.List;

/**
 * 修改后工艺Service接口
 *
 * @author ezhizao
 * @date 2024-04-07
 */
public interface IBizLotTechnologicalProcessService extends IService<BizLotTechnologicalProcess>
{
    /**
     * 查询修改后工艺列表
     *
     * @param bizLotTechnologicalProcess 修改后工艺
     * @return 修改后工艺集合
     */
    public List<BizLotTechnologicalProcess> getList(BizLotTechnologicalProcess bizLotTechnologicalProcess);

    /**
     * 物理删除
     * @param bizLotTechnologicalProcess
     * @return 删除结果
     */
    public int physicalDelete(BizLotTechnologicalProcess bizLotTechnologicalProcess);


    /**
     * 根据id 查询数据
     * @param id
     * @return
     */
    BizLotTechnologicalProcess getById(Long id);

    /**
     * 根据批次ID查询历史修改工艺
     * @param lotId
     * @return
     */
    List<BizLotTechnologicalProcess> selectUpdateList(Long lotId);

}
