package cn.ezhizao.project.business.product.service.impl;

import java.util.List;
import javax.annotation.Resource;

import cn.ezhizao.project.business.product.domain.BizCarrierCategory;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.stereotype.Service;
import cn.ezhizao.project.business.product.mapper.BizCarrierMapper;
import cn.ezhizao.project.business.product.domain.BizCarrier;
import cn.ezhizao.project.business.product.service.IBizCarrierService;

/**
 * 载具详情Service业务层处理
 *
 * @author ezhizao
 * @date 2023-12-04
 */
@Service
public class BizCarrierServiceImpl  extends ServiceImpl<BizCarrierMapper, BizCarrier> implements IBizCarrierService
{
    @Resource
    private BizCarrierMapper bizCarrierMapper;

    /**
     * 查询载具详情列表
     *
     * @param bizCarrier 载具详情
     * @return 载具详情
     */
    @Override
    public List<BizCarrier> getList(BizCarrier bizCarrier)
    {
        return bizCarrierMapper.getList(bizCarrier);
    }

    /**
     * 物理删除
     * @param bizCarrier
     * @return 删除结果
     */
    @Override
    public int physicalDelete(BizCarrier bizCarrier){ return bizCarrierMapper.physicalDelete(bizCarrier); }

    @Override
    public BizCarrierCategory getCarrierCategory(Long id) {
        return bizCarrierMapper.getCarrierCategory(id);
    }

    @Override
    public BizCarrier checkIspection(String carrierCode) {
        return bizCarrierMapper.checkIspection(carrierCode);
    }

    ;

}
