package cn.ezhizao.project.business.product.service.impl;

import java.util.List;
import javax.annotation.Resource;

import cn.ezhizao.project.business.product.domain.BizDayworkItemCollaboration;
import cn.ezhizao.project.business.product.mapper.BizDayworkItemCollaborationMapper;
import cn.ezhizao.project.business.product.service.IBizDayworkItemCollaborationService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.stereotype.Service;

/**
 * 报工记录协作者Service业务层处理
 *
 * @author ezhizao
 * @date 2024-01-18
 */
@Service
public class BizDayworkItemCollaborationServiceImpl  extends ServiceImpl<BizDayworkItemCollaborationMapper, BizDayworkItemCollaboration> implements IBizDayworkItemCollaborationService
{
    @Resource
    private BizDayworkItemCollaborationMapper bizDayworkItemCollaborationMapper;

    /**
     * 查询报工记录协作者列表
     *
     * @param bizDayworkItemCollaboration 报工记录协作者
     * @return 报工记录协作者
     */
    @Override
    public List<BizDayworkItemCollaboration> getList(BizDayworkItemCollaboration bizDayworkItemCollaboration)
    {
        return bizDayworkItemCollaborationMapper.getList(bizDayworkItemCollaboration);
    }

    /**
     * 物理删除
     * @param bizDayworkItemCollaboration
     * @return 删除结果
     */
    @Override
    public int physicalDelete(BizDayworkItemCollaboration bizDayworkItemCollaboration){ return bizDayworkItemCollaborationMapper.physicalDelete(bizDayworkItemCollaboration); };

}
