package cn.ezhizao.project.business.product.service.impl;

import java.util.List;
import javax.annotation.Resource;

import cn.ezhizao.project.business.product.domain.BizDayworkItemConsultPicture;
import cn.ezhizao.project.business.product.mapper.BizDayworkItemConsultPictureMapper;
import cn.ezhizao.project.business.product.service.IBizDayworkItemConsultPictureService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.stereotype.Service;


/**
 * 咨询图片Service业务层处理
 *
 * @author ezhizao
 * @date 2024-07-22
 */
@Service
public class BizDayworkItemConsultPictureServiceImpl  extends ServiceImpl<BizDayworkItemConsultPictureMapper, BizDayworkItemConsultPicture> implements IBizDayworkItemConsultPictureService
{
    @Resource
    private BizDayworkItemConsultPictureMapper bizDayworkItemConsultPictureMapper;

    /**
     * 查询咨询图片列表
     *
     * @param bizDayworkItemConsultPicture 咨询图片
     * @return 咨询图片
     */
    @Override
    public List<BizDayworkItemConsultPicture> getList(BizDayworkItemConsultPicture bizDayworkItemConsultPicture)
    {
        return bizDayworkItemConsultPictureMapper.getList(bizDayworkItemConsultPicture);
    }

    /**
     * 物理删除
     * @param bizDayworkItemConsultPicture
     * @return 删除结果
     */
    @Override
    public int physicalDelete(BizDayworkItemConsultPicture bizDayworkItemConsultPicture){ return bizDayworkItemConsultPictureMapper.physicalDelete(bizDayworkItemConsultPicture); };

}
