package cn.ezhizao.project.business.product.service.impl;

import java.util.List;
import javax.annotation.Resource;

import cn.ezhizao.project.business.product.domain.BizDayworkItemExamine;
import cn.ezhizao.project.business.product.mapper.BizDayworkItemExamineMapper;
import cn.ezhizao.project.business.product.service.IBizDayworkItemExamineService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.stereotype.Service;


/**
 * 分选包装审核申请Service业务层处理
 *
 * @author ezhizao
 * @date 2024-07-29
 */
@Service
public class BizDayworkItemExamineServiceImpl  extends ServiceImpl<BizDayworkItemExamineMapper, BizDayworkItemExamine> implements IBizDayworkItemExamineService
{
    @Resource
    private BizDayworkItemExamineMapper bizDayworkItemExamineMapper;

    /**
     * 查询分选包装审核申请列表
     *
     * @param bizDayworkItemExamine 分选包装审核申请
     * @return 分选包装审核申请
     */
    @Override
    public List<BizDayworkItemExamine> getList(BizDayworkItemExamine bizDayworkItemExamine)
    {
        return bizDayworkItemExamineMapper.getList(bizDayworkItemExamine);
    }

    /**
     * 物理删除
     * @param bizDayworkItemExamine
     * @return 删除结果
     */
    @Override
    public int physicalDelete(BizDayworkItemExamine bizDayworkItemExamine){ return bizDayworkItemExamineMapper.physicalDelete(bizDayworkItemExamine); };

}
