package cn.ezhizao.project.business.product.service.impl;

import java.util.List;
import javax.annotation.Resource;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.stereotype.Service;
import cn.ezhizao.project.business.product.mapper.BizProcessInspectionRelationDetailMapper;
import cn.ezhizao.project.business.product.domain.BizProcessInspectionRelationDetail;
import cn.ezhizao.project.business.product.service.IBizProcessInspectionRelationDetailService;

/**
 * 外协检查关联从表Service业务层处理
 *
 * @author ezhizao
 * @date 2024-10-21
 */
@Service
public class BizProcessInspectionRelationDetailServiceImpl extends ServiceImpl<BizProcessInspectionRelationDetailMapper, BizProcessInspectionRelationDetail> implements IBizProcessInspectionRelationDetailService
{
    @Resource
    private BizProcessInspectionRelationDetailMapper bizProcessInspectionRelationDetailMapper;

    /**
     * 查询外协检查关联从表列表
     *
     * @param bizProcessInspectionRelationDetail 外协检查关联从表
     * @return 外协检查关联从表
     */
    @Override
    public List<BizProcessInspectionRelationDetail> getList(BizProcessInspectionRelationDetail bizProcessInspectionRelationDetail)
    {
        return bizProcessInspectionRelationDetailMapper.getList(bizProcessInspectionRelationDetail);
    }

    /**
     * 物理删除
     * @param bizProcessInspectionRelationDetail
     * @return 删除结果
     */
    @Override
    public int physicalDelete(BizProcessInspectionRelationDetail bizProcessInspectionRelationDetail){ return bizProcessInspectionRelationDetailMapper.physicalDelete(bizProcessInspectionRelationDetail); };

}
