package cn.ezhizao.project.business.product.service.impl;

import java.util.List;
import javax.annotation.Resource;

import cn.ezhizao.project.business.product.domain.BizQuickDayworkNextInfo;
import cn.ezhizao.project.business.product.mapper.BizQuickDayworkNextInfoMapper;
import cn.ezhizao.project.business.product.service.IBizQuickDayworkNextInfoService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.stereotype.Service;

/**
 * 快速报工绑定下序与工段Service业务层处理
 *
 * @author ezhizao
 * @date 2024-04-12
 */
@Service
public class BizQuickDayworkNextInfoServiceImpl  extends ServiceImpl<BizQuickDayworkNextInfoMapper, BizQuickDayworkNextInfo> implements IBizQuickDayworkNextInfoService
{
    @Resource
    private BizQuickDayworkNextInfoMapper bizQuickDayworkNextInfoMapper;

    /**
     * 查询快速报工绑定下序与工段列表
     *
     * @param bizQuickDayworkNextInfo 快速报工绑定下序与工段
     * @return 快速报工绑定下序与工段
     */
    @Override
    public List<BizQuickDayworkNextInfo> getList(BizQuickDayworkNextInfo bizQuickDayworkNextInfo)
    {
        return bizQuickDayworkNextInfoMapper.getList(bizQuickDayworkNextInfo);
    }

    /**
     * 物理删除
     * @param bizQuickDayworkNextInfo
     * @return 删除结果
     */
    @Override
    public int physicalDelete(BizQuickDayworkNextInfo bizQuickDayworkNextInfo){ return bizQuickDayworkNextInfoMapper.physicalDelete(bizQuickDayworkNextInfo); };

}
