package cn.ezhizao.project.business.product.service.impl;


import cn.ezhizao.project.business.product.domain.BizLotTechnologicalProcessDetail;
import cn.ezhizao.project.business.product.mapper.BizLotTechnologicalProcessDetailMapper;
import cn.ezhizao.project.business.product.service.IBizLotTechnologicalProcessDetailService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.List;

/**
 * 工艺修改明细Service业务层处理
 *
 * @author ezhizao
 * @date 2024-04-07
 */
@Service
public class IBizLotLotTechnologicalProcessDetailServiceImpl extends ServiceImpl<BizLotTechnologicalProcessDetailMapper, BizLotTechnologicalProcessDetail> implements IBizLotTechnologicalProcessDetailService
{
    @Resource
    private BizLotTechnologicalProcessDetailMapper bizLotTechnologicalProcessDetailMapper;

    /**
     * 查询工艺修改明细列表
     *
     * @param bizLotTechnologicalProcessDetail 工艺修改明细
     * @return 工艺修改明细
     */
    @Override
    public List<BizLotTechnologicalProcessDetail> getList(BizLotTechnologicalProcessDetail bizLotTechnologicalProcessDetail)
    {
        return bizLotTechnologicalProcessDetailMapper.getList(bizLotTechnologicalProcessDetail);
    }

    /**
     * 物理删除
     * @param bizLotTechnologicalProcessDetail
     * @return 删除结果
     */
    @Override
    public int physicalDelete(BizLotTechnologicalProcessDetail bizLotTechnologicalProcessDetail){ return bizLotTechnologicalProcessDetailMapper.physicalDelete(bizLotTechnologicalProcessDetail); };

}
