package cn.ezhizao.project.business.shaftCategory.service.impl;

import java.util.List;
import javax.annotation.Resource;

import cn.ezhizao.project.business.shaftCategory.mapper.BizShaftCategoryMapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.stereotype.Service;

import cn.ezhizao.project.business.shaftCategory.domain.BizShaftCategory;
import cn.ezhizao.project.business.shaftCategory.service.IBizShaftCategoryService;

/**
 * 盘点同步Service业务层处理
 *
 * @author ezhizao
 * @date 2023-11-15
 */
@Service
public class BizShaftCategoryServiceImpl  extends ServiceImpl<BizShaftCategoryMapper, BizShaftCategory> implements IBizShaftCategoryService
{
    @Resource
    private BizShaftCategoryMapper bizShaftCategoryMapper;

    /**
     * 查询盘点同步列表
     *
     * @param bizShaftCategory 盘点同步
     * @return 盘点同步
     */
    @Override
    public List<BizShaftCategory> getList(BizShaftCategory bizShaftCategory)
    {
        return bizShaftCategoryMapper.getList(bizShaftCategory);
    }

    /**
     * 物理删除
     * @param bizShaftCategory
     * @return 删除结果
     */
    @Override
    public int physicalDelete(BizShaftCategory bizShaftCategory){ return bizShaftCategoryMapper.physicalDelete(bizShaftCategory); };

}
