package cn.ezhizao.project.business.storageRetrieval.domain;

import cn.ezhizao.framework.aspectj.lang.annotation.Excel;
import cn.ezhizao.framework.web.domain.BaseEntity;
import com.baomidou.mybatisplus.annotation.FieldFill;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableName;

import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Data;
import io.swagger.annotations.ApiModelProperty;

import java.util.Date;
import java.util.List;


/**
 * 零存零取对象 biz_storage_retrieval
 *
 * @author ezhizao
 * @date 2024-10-11
 */
@Data
@TableName(value = "biz_storage_retrieval")
public class BizStorageRetrieval extends BaseEntity
{
    private static final long serialVersionUID = 1L;

    /** 租户（厂别）id */
    @ApiModelProperty(value = "${comment}")
    private Long tenantId;

    /** 计划单明细id */
    @ApiModelProperty(value = "${comment}")
    private Long productionPlanDetailId;

    /** 产品描述 */
    @Excel(name = "产品描述")
    @ApiModelProperty(value = "产品描述")
    private String productDescription;

    /** 产品图号 */
    @Excel(name = "产品图号")
    @ApiModelProperty(value = "产品图号")
    private String drawingNumber;

    /** 批次id */
    @ApiModelProperty(value = "产品图号")
    private Long lotId;

    /** 批次号 */
    @Excel(name = "批次号")
    @ApiModelProperty(value = "批次号")
    private String lotCode;

    /** 工段id（当前工段的id） */
    @ApiModelProperty(value = "批次号")
    private Long deptId;

    /** 产品id */
    @ApiModelProperty(value = "批次号")
    private Long productId;

    /** 工艺版本号 */
    @Excel(name = "工艺版本号")
    @ApiModelProperty(value = "工艺版本号")
    private String technologyVersion;

    /** 零存数量 */
    @Excel(name = "零存数量")
    @ApiModelProperty(value = "零存数量")
    private Long storageNum;

    /** 存录员 */
    @ApiModelProperty(value = "零存数量")
    private Long storagerId;

    /** 是否被取出（0：否，1：是 */
    @Excel(name = "是否被取出", readConverterExp = "是否被取出（0：否，1：是")
    @ApiModelProperty(value = "是否被取出")
    private Integer status;

    /** 取出批次号 */
    @Excel(name = "取出批次号")
    @ApiModelProperty(value = "取出批次号")
    private String retrievalLotCode;

    /** 取出批次id */
    @ApiModelProperty(value = "取出批次号")
    private Long retrievalLotId;

    /** 取出员 */
    @ApiModelProperty(value = "取出批次号")
    private Long retrievalerId;

    @TableField(exist = false)
    private List<BizStorageRetrieval> hasAddedList;
    private String retrievalTime;
    @TableField(exist = false)
    private List<Long> hasAddIds;
    @TableField(exist = false)
    private String storagerName;
    private Integer type;

}
