package cn.ezhizao.project.business.taksStockLot.service.impl;

import java.util.List;
import javax.annotation.Resource;

import cn.ezhizao.project.business.taksStockLot.domain.BizTaksStockLot;
import cn.ezhizao.project.business.taksStockLot.mapper.BizTaksStockLotMapper;
import cn.ezhizao.project.business.taksStockLot.service.IBizTaksStockLotService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.stereotype.Service;


/**
 * 盘点批次信息Service业务层处理
 *
 * @author ezhizao
 * @date 2024-08-15
 */
@Service
public class BizTaksStockLotServiceImpl  extends ServiceImpl<BizTaksStockLotMapper, BizTaksStockLot> implements IBizTaksStockLotService
{
    @Resource
    private BizTaksStockLotMapper bizTaksStockLotMapper;

    /**
     * 查询盘点批次信息列表
     *
     * @param bizTaksStockLot 盘点批次信息
     * @return 盘点批次信息
     */
    @Override
    public List<BizTaksStockLot> getList(BizTaksStockLot bizTaksStockLot)
    {
        return bizTaksStockLotMapper.getList(bizTaksStockLot);
    }

    /**
     * 物理删除
     * @param bizTaksStockLot
     * @return 删除结果
     */
    @Override
    public int physicalDelete(BizTaksStockLot bizTaksStockLot){ return bizTaksStockLotMapper.physicalDelete(bizTaksStockLot); };

}
