package cn.ezhizao.project.business.technologicalProcess.service.impl;

import java.util.List;
import javax.annotation.Resource;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.stereotype.Service;
import cn.ezhizao.project.business.technologicalProcess.mapper.BizTechnologicalProcessMapper;
import cn.ezhizao.project.business.technologicalProcess.domain.BizTechnologicalProcess;
import cn.ezhizao.project.business.technologicalProcess.service.IBizTechnologicalProcessService;

/**
 * 工艺主表Service业务层处理
 *
 * @author ezhizao
 * @date 2023-11-13
 */
@Service
public class BizTechnologicalProcessServiceImpl  extends ServiceImpl<BizTechnologicalProcessMapper, BizTechnologicalProcess> implements IBizTechnologicalProcessService
{
    @Resource
    private BizTechnologicalProcessMapper bizTechnologicalProcessMapper;

    /**
     * 查询工艺主表列表
     *
     * @param bizTechnologicalProcess 工艺主表
     * @return 工艺主表
     */
    @Override
    public List<BizTechnologicalProcess> getList(BizTechnologicalProcess bizTechnologicalProcess)
    {
        return bizTechnologicalProcessMapper.getList(bizTechnologicalProcess);
    }

    /**
     * 物理删除
     * @param bizTechnologicalProcess
     * @return 删除结果
     */
    @Override
    public int physicalDelete(BizTechnologicalProcess bizTechnologicalProcess){ return bizTechnologicalProcessMapper.physicalDelete(bizTechnologicalProcess); };

}
