package cn.ezhizao.project.business.workshop.domain;

import cn.ezhizao.framework.aspectj.lang.annotation.Excel;
import cn.ezhizao.framework.web.domain.BaseEntity;
import cn.ezhizao.project.system.domain.SysDept;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableName;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.util.List;


/**
 * 车间管理对象 biz_workshop
 *
 * @author ezhizao
 * @date 2024-02-22
 */
@Data
@TableName(value = "biz_workshop")
public class BizWorkshop extends BaseEntity
{
    private static final long serialVersionUID = 1L;

    /** 车间名称 */
    @Excel(name = "车间名称")
    @ApiModelProperty(value = "车间名称")
    private String name;

    /** 租户id */
    @ApiModelProperty(value = "车间名称")
    private Long tenantId;

    @TableField(exist = false)
    private List<SysDept> depts;

}
