package cn.ezhizao.project.tenant.service.impl;

import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import cn.ezhizao.project.tenant.domain.BizTenantApply;
import cn.ezhizao.project.tenant.mapper.BizTenantApplyMapper;
import cn.ezhizao.project.tenant.service.IBizTenantApplyService;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.List;

/**
 * 企业加入申请记录Service业务层处理
 *
 * @author zhushan
 * @date 2023-08-31
 */
@Service
public class BizTenantApplyServiceImpl  extends ServiceImpl<BizTenantApplyMapper, BizTenantApply> implements IBizTenantApplyService
{
    @Resource
    private BizTenantApplyMapper bizTenantApplyMapper;

    /**
     * 查询企业加入申请记录列表
     *
     * @param bizTenantApply 企业加入申请记录
     * @return 企业加入申请记录
     */
    @Override
    public List<BizTenantApply> getList(BizTenantApply bizTenantApply)
    {
        return bizTenantApplyMapper.getList(bizTenantApply);
    }

    /**
     * 物理删除
     * @param bizTenantApply
     * @return 删除结果
     */
    @Override
    public int physicalDelete(BizTenantApply bizTenantApply){ return bizTenantApplyMapper.physicalDelete(bizTenantApply); };

}
